from PASTEC.utils.AbstractClassifierAgent import AbstractClassifierAgent
from PASTEC.Decision import Condition, NumericRule

class HG_profilesAdaptatorAgent(AbstractClassifierAgent):

    def __init__(self, env):
        AbstractClassifierAgent.__init__(self, env)
        self._listOfKnownAgents = ["Profiles_Agent"]
        self.CONDITIONS = {"classif_other":  [Condition([NumericRule(self._environment.getMinHGProfilesCoverage(), ">")], [], 1)],
                          "classif_BM":     [],
                          "weighting":      []}
        #TODO: Numeric rule conditions should perhaps be a dict, with the target  key of _dNumericData (example if we want to do a validation of coverage conditions etc):
        #ie self._dNumericData["coverage"] != self._dNumericData["sizeWithouthTR"] (the default element checked by NumericRule conditions)
    
    def getAgentName(self):
        return "PotentialHostGene"

    def makeAppropriateConclusionsForProfiles_Agent(self, iDemandAndResult):
        if iDemandAndResult and iDemandAndResult.result:
            lPDM = iDemandAndResult.result
            for iPDM in lPDM:
                self._dNumericData["coverage"].append(iPDM.getCoverage())
                self._dNumericData["coverageOnSubject"].append(iPDM.getCoverageOnSubject())
            self._conclusionsMatch.append({'profilesOTHER': lPDM})


    def decide(self):
        isAConditionValid = False
        lOtherConditions = self.CONDITIONS["classif_other"]
        for iCondition in lOtherConditions:
            if iCondition.validate(self._dNumericData["coverage"], self._dPresenceData["classif_other"]):
                isAConditionValid = True
                self._CI += iCondition.getWeight()
                
        lBMConditions = self.CONDITIONS["classif_BM"]
        for iCondition in lBMConditions:
            if iCondition.validate(None, self._dPresenceData["classif_BM_tblastx"]):
                isAConditionValid = True
                self._CI += iCondition.getWeight()
            if iCondition.validate(None, self._dPresenceData["classif_BM_blastx"]):
                isAConditionValid = True
                self._CI += iCondition.getWeight()
                
        if self._dPresenceData["classif_nb"]:
            isAConditionValid = True
            self._CI += self._dPresenceData["classif_nb"]
                
        if isAConditionValid:
            self._weightCI()
        
        normalizedIC = self._normalizeIC()
        return self._classification, normalizedIC