#-----------------------------------------------------------------------
# Return the table type
#-----------------------------------------------------------------------
def type_table (table,db):
    type=""
    show='show columns from %s;'      
    sql=show%(table)
    db.execute(sql)
    res=db.fetchall()
    if res[0][0]=="path":
        name=res[1][0]
        if name=="name" and len(res)==5:
            type="set"
        if name=="query_name" and len(res)==10:
            type="path"
    else:
        name=res[0][0]
        if name=="name" and len(res)==4:
            type="map"
        if name=="query_name" and len(res)==9:
            type="align"
    return type



#-----------------------------------------------------------------------
# Detect if the sequence contain repeat sequence
#-----------------------------------------------------------------------
def extract_repeat_in(type,repeattable,chr,start,end,db):
    result=()
    if type=="set" or type=="map":
        select='select * from %s where chr = "%s"\
        and (least(start,end) between least(%d,%d) and greatest(%d,%d)\
        and greatest(start,end) between least(%d,%d) and greatest(%d,%d));'    

    if type=="path" or type=="match" or type=="align":
        select='select * from %s where query_name="%s"\
        and (least(query_start,query_end) between least(%d,%d) and greatest(%d,%d)\
        and greatest(query_start,query_end) between least(%d,%d) and greatest(%d,%d));' 

    if type!="set" and type!="map" and type!="path" and type!="match" and type!="align":
        print "Error Type Table"
        return result

    sql_cmd=select%(repeattable,chr,start,end,start,end,start,end,start,end)
    db.execute(sql_cmd)
    result=db.fetchall()
    return result



#-----------------------------------------------------------------------
# Detect if two map sequences are overlapped
#-----------------------------------------------------------------------
def overlap_map(map1,map2,db):  
    create_tmp='create table tmp (name vachar(255),chr varchar(255),start int(11),end int(11));'
    sql=create_tmp%(map1.name,map1.seqname,map1.start,map1.end)
    db.execute(sql)
    result=extract_repeat_overlap(map,"tmp",map2.seqname,map2.start,map2.end,db)
    db.execute('drop table tmp;')
    return result


#-----------------------------------------------------------------------
# Detect if the sequence is in repeats (with a extend of X bp)
#-----------------------------------------------------------------------
def extract_repeat_out_extend(type,repeattable,chr,start,end,val,db):
    result=()
    if type=="set" or type=="map":
        select='select * from %s where chr = "%s"\
        and least(%d,%d)>= least(start,end)-%d and greatest(%d,%d)<= greatest(start,end)+%d;'
        
    if type=="path" or type=="match" or type=="align":
        select='select * from %s where query_name="%s"\
        and least(%d,%d)>= least(query_start,query_end)-%d and greatest(%d,%d)<= greatest(query_start,query_end)+%d;'

    if type!="set" and type!="map" and type!="path" and type!="match" and type!="align":
        print "Error Type Table"
        return result

    sql=select%(repeattable,chr,start,end,val,start,end,val)    
    db.execute(sql)
    result=db.fetchall()
    return result


#-----------------------------------------------------------------------
# Detect if the sequence overlapping repeat sequence
#-----------------------------------------------------------------------
def extract_repeat_overlap(type,repeattable,chr,start,end,db):
    result=()
    if type=="set" or type=="map":
        select='select * from %s where chr = "%s"\
        and (least(start,end) between least(%d,%d) and greatest(%d,%d)\
        or greatest(start,end) between least(%d,%d) and greatest(%d,%d)\
        or (least(start,end)<=least(%d,%d) and greatest(start,end)>=greatest(%d,%d)));'    

    if type=="path" or type=="match" or type=="align":
        select='select * from %s where query_name="%s"\
        and (least(query_start,query_end) between least(%d,%d) and greatest(%d,%d)\
        or greatest(query_start,query_end) between least(%d,%d) and greatest(%d,%d)\
        or (least(query_start,query_end)<=least(%d,%d) and greatest(query_start,query_end)>=greatest(%d,%d)));' 

    if type!="set" and type!="map" and type!="path" and type!="match" and type!="align":
        print "Error Type Table"
        return result

    sql=select%(repeattable,chr,start,end,start,end,start,end,start,end,start,end,start,end)
    db.execute(sql)
    result=db.fetchall()
    return result


#-----------------------------------------------------------------------
# Detect and count repeats of the end of the sequence
#-----------------------------------------------------------------------
def extract_numberRepeat_end(type,repeattable,chr,start,end,db):
    count=0
    minpos=""
    maxpos=""
    pos=""
    size_start=0
    size_end=0
    
    if type=="set" or type=="map":
        startRepet='select * from %s where chr="%s"\
        and (%d between least(start,end) and greatest(start,end)) \
        and %d>greatest(start,end);'

        endRepet='select * from %s where chr="%s"\
        and (%d between least(start,end) and greatest(start,end)) \
        and %d<least(start,end);'



    if type=="path" or type=="match" or type=="align":
        startRepet='select * from %s where query_name="%s"\
        and (%d between least(query_start,query_end) and greatest(query_start,query_end)) \
        and %d>greatest(query_start,query_end);'

        endRepet='select * from %s where query_name="%s"\
        and (%d between least(query_start,query_end) and greatest(query_start,query_end)) \
        and %d<least(query_start,query_end);' 
        
    if type!="set" and type!="map" and type!="path" and type!="match" and type!="align":
        print "Error Type Table"
        return count

    startsql=startRepet%(repeattable,chr,start,end)
    db.execute(startsql)
    result_start=db.fetchall()
    if result_start!=():
        #print result_start[0]
        size_start=int(result_start[0][4])-int(result_start[0][3])
        minpos="min"+str(start)
        count=count+1
    
    endsql=endRepet%(repeattable,chr,end,start)
    db.execute(endsql)
    result_end=db.fetchall()
    if result_end!=():
        #print result_end[0]
        size_end=int(result_end[0][4])-int(result_end[0][3])
        maxpos="max"+str(end)
        count=count+1
        
    if count==1 and minpos!="":
        pos=minpos
    if count==1 and maxpos!="":
        pos=maxpos
    if count==2:
        pos=minpos+""+maxpos

    return count,pos,size_start,size_end


#-----------------------------------------------------------------------
# Detection of macrotransposition
# (i)  Detect if repeats of the sequence ends belong to the same class and family
# (ii) Detect target site duplication with TSDsearch
#-----------------------------------------------------------------------
