#!/usr/bin/env python

import os

startupfilename = os.environ.get('PYTHONSTARTUP')
if startupfilename and os.path.isfile(startupfilename):
    execfile(startupfilename)

import sys
import getopt
from commons.core.coord.Align import Align
from commons.core.sql.DbFactory import DbFactory
from SegDup_pipe.ExtractTable import extract_repeat_overlap
from SegDup_pipe.ExtractTable import type_table
from SegDup_pipe.ExtractTable import extract_repeat_out_extend
        
def detect_overlap (table,query,repet):
    newresult=[]
    type=type_table(table,repet)
    result=extract_repeat_overlap(type,table,query.seqname,query.start,query.end,repet)
    i=0
    for r in result:
        if type=="path":
            newresult.append((int(r[0]),r[4],r[1],int(r[2]),int(r[3])))
        if type=="align":
            newresult.append((i,r[4],r[1],int(r[2]),int(r[3])))
        if type=="map":
            newresult.append((i,r[0],r[1],int(r[2]),int(r[3])))
        if type=="set":
            newresult.append((int(r[0]),r[1],r[2],int(r[3]),int(r[4])))  
        i=i+1
    return newresult

#def over_set_list(list_tables,query,repet):
#    subject_list=[]
#    subject_list_merge=[]    
#    for table in list_tables:
#        result=detect_overlap(table,query,repet)
#        if result !=[] :
#            for i in range(len(result)):
#                obj=Set()
#                obj.set_from_tuple(result[i])
#                subject_list.append(obj)
#                subject_list_merge=set_list_merge(subject_list)
#    return subject_list_merge

def help ():
    print "usage:",sys.argv[0],"[options] "
    print "options:"
    print "    -h: this help"
    print "    -b: blast out file "
    print "    -t: TE annotations (tables Set or Path)"
    print "    -s: SAT annotations (tables Set or Path)"
    print "    -o: overtaking in bp"
    print "    -e: out table name with no repet"
    sys.exit(0)

def main ():
    out_blast=""
    TE_annot=[]
    SAT_annot=[]
    val=10
    noRepetTableName = ""
    
    opts,args = getopt.getopt(sys.argv[1:],"b:o:t:e:s:h")
    for o,a in opts:
        if o == "-h":
            help()
        if o == "-b":
            out_blast=a
        if o == "-t":
            TE_annot.append(a)
        if o == "-s":
            SAT_annot.append(a)
        if o == "-o":
            try:
                val=int(a)
            except ValueError:
                print "ValueError: invalid literal for int() "
                help()
        if o == "-e":
            noRepetTableName = a

    repet = DbFactory.createInstance()

    dico_tables={}
    dico_tables["TE"]=TE_annot
    dico_tables["SAT"]=SAT_annot
#    size=len(out_blast.split("/"))
#    table_name=out_blast.split("/")[size-1].replace('-','_').replace('.','_')
    table_name = noRepetTableName
    repet.createTable(table_name, "align", overwrite = True)
#    repet.dropTable(table_name)
#    create='create table %s (query_name varchar(255),query_start int(10) unsigned,\
#    query_end int(10) unsigned,subject_name varchar(255),subject_start int(10) unsigned,\
#    subject_end int(10) unsigned,E_value double,score int(10) unsigned,identity float,\
#    index query (query_name,query_start,query_end),\
#    index subject (subject_name,subject_start,subject_end));'
#    sql=create%(table_name)
#    repet.execute(sql)

    fichier=open(out_blast)
    b=Align()
    i=0
    j=0
    
    while b.read(fichier): 
        qresult=()
        sresult=()
        
        # verif if the repeats are include in a single known repeat (transposable elements, satellites ...)
        for Annot in dico_tables.keys():
            for table in dico_tables[Annot]:
                Ttype=type_table(table,repet)
                qresult=qresult+(extract_repeat_out_extend(Ttype,table,b.range_query.seqname,b.range_query.start,b.range_query.end,val,repet))
                sresult=sresult+(extract_repeat_out_extend(Ttype,table,b.range_subject.seqname,b.range_subject.start,b.range_subject.end,val,repet))

        if qresult==() and sresult==():# if the repeats are not included in a single known repeat
            i=i+1
            insert='insert delayed into %s values ("%s",%d,%d,"%s",%d,%d,%f,%d,%f);'
            sql=insert%(table_name,b.range_query.seqname,b.range_query.start,b.range_query.end,\
                        b.range_subject.seqname,b.range_subject.start,b.range_subject.end,\
                        b.e_value,b.score,b.identity)
            repet.execute(sql)
        else:
            j=j+1
    print "Total="+str(i+j)+"\tNoRepet="+str(i)+"\tRepet="+str(j)
    
if __name__ == "__main__": 
    main ()