#!/bin/bash

if [[ $# -ne 1 ]];
    then
        echo "usage:" $0 "<config filename>";
        exit 1;
    fi;

. $1


if [[ ! -e $root_dir/gamexml ]]; then
mkdir $root_dir/gamexml
fi
pushd $root_dir/gamexml

#prepare source (empty) gamexml
if [[ ! -e src_gamexml ]]; then
    mkdir src_gamexml
    cd src_gamexml
    ln -s $db_dir/$geno_db $geno_db
    srptGameXmlMaker.py -f $geno_db
    rename gamexml.new gamexml.ori *.new
    rm $geno_db
    cd ..
fi

echo "copying ori files"
cp src_gamexml/*.ori .
rename gamexml.ori gamexml *.ori

echo "start building"
cdir=`pwd`

for i in *.gamexml; 
do 

qsub -q long -l "mem=500Mb" -j oe -o $cdir -N job${i:5:8} <<EOF
cd $cdir
. ../../setdb.sh
srptGameXmlMaker.py -t table_file.txt -g $i;
mv $i.new $i
EOF

done
 
popd
