#!/usr/bin/env bash

if [[ $# -ne 1 ]];
    then
        echo "usage:" $0 "<config filename>";
        exit 1;
    fi;

. $1

chk_dir_name=`echo $chunk_rnd_dir | sed s/"\/$"// | awk -F"/" '{print $(NF)}'`
echo ${chk_dir_name}

#-----------------------------------------------------------------

BLRn () {
if [[ ! -e BLRn ]]; then
mkdir BLRn
fi
cd BLRn
srptBLR.py -b BLRn -B " -W" -m -t jobs -d ${db_dir} -q ${chk_dir_name} -s ${TElib} -g BLRrnd_${TElib_prefix} -Q $queue_name
cd ..
}

#-----------------------------------------------------------------

RM () {
if [[ ! -e RM ]]; then
mkdir RM
fi
cd RM
#srptRM.py -w -p "-cutoff 200" -t jobs -d ${db_dir} -q ${chk_dir_name} -s ${TElib} -g RMrnd_${TElib_prefix} -Q $queue_name
srptRM.py  -p "-cutoff 200" -t jobs -d ${db_dir} -q ${chk_dir_name} -s ${TElib} -g RMrnd_${TElib_prefix} -Q $queue_name
cd ..
}

#-----------------------------------------------------------------

CEN () {
if [[ ! -e CEN ]]; then
mkdir CEN
fi
cd CEN
srptCEN.py -p "-s" -t jobs -d ${db_dir} -q ${chk_dir_name} -s ${TElib} -g CENrnd_${TElib_prefix} -Q $queue_name
cd ..
}

#-----------------------------------------------------------------
#-----------------------------------------------------------------

date

cd $root_dir

if [[ ! -e CombBLRrnd_$TElib_prefix ]]; then
mkdir CombBLRrnd_$TElib_prefix
fi
cd CombBLRrnd_$TElib_prefix

#BLRn
CEN
RM

echo $0 " finished successfully !"
date
