#!/usr/bin/env python2

import os
startupfilename = os.environ.get('PYTHONSTARTUP')
if startupfilename and os.path.isfile(startupfilename):
    execfile(startupfilename)

import getopt
import sys
import string
import re
from pyRepet.sql.TableAdaptator import *
from pyRepet.sql.RepetDBMySQL import *
import pyRepet.coord.Map
import pyRepet.coord.Path
import pyRepet.coord.Set

def help():
        print "usage:",sys.argv[0]," [ options ]"
        print "option:"
        print "    -h: this help"
        print "    -q: table"
        print "    -t: table types ([path,set])"

def main ():
    
    qtable=""
    qtype=""
    
    opts, args = getopt.getopt(sys.argv[1:],"hq:t:")
    if len(args) != 0:
        help()
        return 1
    for o,a in opts:
        if o == "-h":
            help()
        if o == "-q":
            qtable=a
        if o == "-t":
            qtype=a

    if qtable=="" or qtype=="":
        help()
        return
    
    db=RepetDB()

    if qtype=="path":
        db.create_path_index(qtable)
        qtableAdaptator=TableBinPathAdaptator(db,qtable)
    elif qtype=="set":
        db.create_set_index(qtable)
        qtableAdaptator=TableBinSetAdaptator(db,qtable)
    else:
        print "Unknown query table type:",qtype

    path_num_list=qtableAdaptator.getSet_num()
    
    path2check=[]
    count=0
    for path_num in path_num_list:
        qlist=qtableAdaptator.getSetList_from_num(path_num)

        qlist.sort()
        qmin,qmax=pyRepet.coord.Set.set_list_boundaries(qlist)

        qmin=qmin-1
        qmax=qmax+1
        slist=qtableAdaptator.getSetList_from_qcoord(qlist[0].seqname.split()[0],qmin,qmax)

        
        if len(slist)>0:
            print "----------------------------------------"
            print "annot:"
            pyRepet.coord.Set.set_list_show(qlist)
            qlist=pyRepet.coord.Set.set_list_merge(qlist)
            qsize=pyRepet.coord.Set.set_list_size(qlist)
            print "annot size=",qsize

        dl=pyRepet.coord.Set.set_list_split(slist)
        for p in dl.keys():
            if p==qlist[0].id:
                continue
            l=dl[p]
            osize=pyRepet.coord.Set.set_list_overlap_size(qlist,l)
            if osize>0:
                pyRepet.coord.Set.set_list_show(l)
                print "Overlap %d --> check path %d and %d"%(osize,qlist[0].id,p)
                path2check.append((qlist[0].id,p))
                count=count+1

    print "Number of path to check:",count
    path2check.sort()
    print path2check
    for i,j in path2check:
        print i, "<-?->",j

if __name__ == "__main__": 
    main ()
