#!/usr/bin/env python2

import os
startupfilename = os.environ.get('PYTHONSTARTUP')
if startupfilename and os.path.isfile(startupfilename):
    execfile(startupfilename)

import getopt
import sys
import string
import re
import pyRepet.sql.TableAdaptator
from pyRepet.sql.RepetDBMySQL import *
import pyRepet.coord.Map
import pyRepet.coord.Path
import pyRepet.coord.Set

def help():
        print "usage:",sys.argv[0]," [ options ]"
        print "option:"
        print "    -h: this help"
        print "    -q: annot set table"
        print "    -s: path ref table"
        print "    -a: alias table"

def main ():
    
    qtable=""
    stable=""
    alias=""
    type=""
    
    opts, args = getopt.getopt(sys.argv[1:],"hq:s:a:")
    if len(args) != 0:
        help()
        return 1
    for o,a in opts:
        if o == "-h":
            help()
        if o == "-q":
            qtable=a
        if o == "-s":
            stable=a
        if o == "-a":
            alias=a

    if qtable=="" or stable=="":
        help()
        return
    
    db=RepetDB()

    id2name={}
    if alias!="":
        db.execute('SELECT id,name FROM %s;'%(alias))
        result=db.fetchall()
        if result==():
            print "no alias table:",alias
        for i in result:
            id2name[i[0]]=i[1]

    new_qtable=qtable+"_renamed"
    db.copy_table(qtable,new_qtable)
    
    sql_cmd='SELECT * FROM '+new_qtable+' WHERE name like "CG:temp%" ORDER BY path;'
    print "fetching query table data ..."
    db.execute(sql_cmd)
    res=db.fetchall()
    qlist=[]
    count=0
    tablePathAdaptator=pyRepet.sql.TableAdaptator.TablePathAdaptator(db,stable)
    tableSetAdaptator=pyRepet.sql.TableAdaptator.TableSetAdaptator(db,new_qtable)
    print "looking subject data ..."
    for i in res:
        p=pyRepet.coord.Set.Set()
        p.set_from_tuple(i)
        qs=p
        if qlist!=[] and qs.id!=qlist[-1].id:
            qlist.sort()
            qmin=qlist[0].getMin()
            qmax=qlist[-1].getMax()
            slist=tablePathAdaptator.getPathList_from_qcoord(qlist[0].seqname.split()[0],qmin,qmax)
            slist=pyRepet.coord.Path.path_list_rangeQ2Set(slist)
            if len(slist)>0:
                by_id_list=pyRepet.coord.Set.set_list_split(slist)
                max_over=-1
                max_id=-1
                print "----------------------------------------"
                print "annot:"
                pyRepet.coord.Set.set_list_show(qlist)
                for id,l in by_id_list.items():
                    osize=pyRepet.coord.Set.set_list_overlap_size(qlist,l)
                    print "ref:"
                    pyRepet.coord.Set.set_list_show(l)
                    print "overlap size=",osize
                    if osize>max_over:
                        max_over=osize
                        max_id=id

                if max_id>0:
                    if alias!="":
                        name=id2name[by_id_list[max_id][0].name.split("|")[-1]]
                    else:
                        name=by_id_list[max_id][0].name
                    print "name is",name
                    for j in xrange(len(qlist)):
                        qlist[j].name=name
                        
                    print "new annot:"
                    pyRepet.coord.Set.set_list_show(qlist)
                    print "best id",str(max_id),",change path %d"%(qlist[0].id)
                    tableSetAdaptator.delSet_from_num(qlist[0].id)
                    tableSetAdaptator.insSetList(qlist)

                    
                    count=count+1
            else:
                print "remove",str(qlist[0].id)
                tableSetAdaptator.delSet_from_num(qlist[0].id)

            qlist=[qs]
        else:
            qlist.append(qs)

    print "Number of path to change:",count

    
if __name__ == "__main__": 
    main ()


