#!/usr/bin/env python2

import os
startupfilename = os.environ.get('PYTHONSTARTUP')
if startupfilename and os.path.isfile(startupfilename):
    execfile(startupfilename)

import getopt
import sys
import string
import pyRepet.seq.Bioseq
import pyRepet.seq.AlignedBioseqDB
import pyRepet.util.Stat

def help():
        print "usage:",sys.argv[0]," [ options ] <fasta alignment filename>"
        print "option:"
        print "    -h: this help"

def main ():
    opts, args = getopt.getopt(sys.argv[1:],"h")
    if len(args) < 1:
        help()
        return 1
    for o,a in opts:
        if o == "-h":
            help()

    filename=args[0]
    
    dba=pyRepet.seq.AlignedBioseqDB.AlignedBioseqDB()
    dba.load(filename)
    data_id=dba.pairwise_identity()
    data_del=dba.gap()
    min_id={}
    max_id={}
    stat_id=pyRepet.util.Stat.Quantile()
    stat_del=pyRepet.util.Stat.Quantile()

    gap={}
    for i in data_del:
        stat_del.add(i[1])
        gap[i[0]]=i[1]
        
    for i in data_id:
        if i[2]==0.0:
            continue
        stat_id.add(i[2])

        if max_id.has_key(i[0]):
            if max_id[i[0]][0]<i[2]:
                max_id[i[0]]=(i[2],i[1])
        else:
            max_id[i[0]]=(i[2],i[1])
            
        if max_id.has_key(i[1]):
            if max_id[i[1]][0]<i[2]:
                max_id[i[1]]=(i[2],i[0])
        else:
            max_id[i[1]]=(i[2],i[0])        

        if min_id.has_key(i[0]):
            if min_id[i[0]][0]>i[2]:
                min_id[i[0]]=(i[2],i[1])
        else:
            min_id[i[0]]=(i[2],i[1])
            
        if min_id.has_key(i[1]):
            if min_id[i[1]][0]>i[2]:
                min_id[i[1]]=(i[2],i[0])
        else:
            min_id[i[1]]=(i[2],i[0])        


    for i in max_id.keys():
        print "%s\t%2.2f\t%s\t%2.2f\t%s\t%2.2f"\
              %(i,min_id[i][0],min_id[i][1],\
                max_id[i][0],max_id[i][1],gap[i])

    print
    print "\tmin\tQ5\tQ25\tmedian\tmean\tQ75\tQ95\tmax"
    print "Stat Identity\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f"%\
          (stat_id.min,stat_id.quantile(0.05),stat_id.quantile(0.25),stat_id.quantile(0.5),stat_id.mean(),stat_id.quantile(0.75),stat_id.quantile(0.95)\
           ,stat_id.max)
    print "Stat Gap\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f\t%5.3f"%\
          (stat_del.min,stat_del.quantile(0.05),stat_del.quantile(0.25),stat_del.quantile(0.5),stat_del.mean(),stat_del.quantile(0.75),stat_del.quantile(0.95)\
           ,stat_del.max)


    
if __name__ == "__main__": 
    main ()




