import os
import unittest
from LauncherBlasterNotInParallel import *
from pyRepet.util.file.FileUtils import *

class TestLauncherBlasterNotInParallel(unittest.TestCase):
  
    def setUp(self):
        self._quertyDir = "./datas/projectName" 
        self._subjectSequence =  "./datas/projectName.fa" 
        self._configFile = "./datas/config.cfg"
        self.launcher = LauncherBlasterNotInParallel()
   
    def testRun (self):
        # TODO consider the REPET_PATH
        self.launcher.setSubjectInputSequence(self._subjectSequence)
        self.launcher.setQueryInputFolder(self._quertyDir)
        self.launcher.setConfigFile(self._configFile)
        self.launcher.run()
        fileUtils = FileUtils()
        # TODO why datas as output dir ?
        dirFiles = fileUtils.listDir("./datas")
        
        found = 0
        for file in dirFiles:
            if (file == "./datas/projectName.align"):
                found = 1
                break
        self.assertTrue(found == 1)
        self._clean()
        
    def _clean(self):
        os.system("rm ./datas/projectName.align")
        os.system("rm ./datas/projectName.fa_cut")
        os.system("rm ./datas/projectName.fa_cut.nhr")
        os.system("rm ./datas/projectName.fa_cut.nin")
        os.system("rm ./datas/projectName.fa_cut.nsq")
        os.system("rm ./datas/projectName.fa.Nstretch.map")
        os.system("rm ./datas/projectName.seq_treated")
        os.system("rm ./datas/projectName.param")
        os.system("rm ./datas/projectName.raw")

if __name__ == "__main__":
        unittest.main()

