#!/usr/bin/env python

import sys
import copy
import bisect
from pyRepet.coord.Range import *
from pyRepet.seq.Bioseq import *
from AlignedBioseqDBfab_tim import *
from pyRepet.seq.BioseqDB import *
from ClustalToAlbDB import *

#------------------------------------------------------------------------------

class AlignGraph:

    #--------------------------------------------------------------------------

    def __init__(self,pathlist,sign_of_Ref,fasta,name_length):

        self.list_of_path=pathlist
##         self.listcopy=copy.deepcopy(pathlist)
        self.sign_of_ref=sign_of_Ref
        self.name2length=name_length
        self.currentpath=None
        self.currentpathori=None
        self.complementary=None
        self.complementaryQ=None
        self.complementaryS=None
        self.type=None
        self.AlbDB=None
        self.Fastafile=fasta
        self.number_of_clustal=None
        self.profil=None
        self.index=None
        self.dico={}
        self.dico_profil={}
        self.profils_to_align=[]
        self.query_overlap=None
        self.subject_overlap=None
        self.profil_father=None
        self.dupli=0

#------------------------------------------------------------------------------

    def Build_ListForAlign(self):
        list_for_alignment=[]
        for path in self.list_of_path:
            list_for_alignment.append(path)
            print path.range_query.start,path.range_query.end,path.range_subject.start,path.range_subject.end
        return list_for_alignment

#------------------------------------------------------------------------------

    def take_the_good_strand(self,range):
        if range.isPlusStrand():
            if self.sign_of_ref[range.seqname]=='+':
                self.complementary=0
            elif self.sign_of_ref[range.seqname]=='-':
                length=self.name2length[range.seqname]+1
                range.start=length-range.start
                range.end=length-range.end
                range.reverse() # normalement reverse est necessaire
                self.complementary=1
        elif not range.isPlusStrand():
            if self.sign_of_ref[range.seqname]=='+':
                range.reverse()
                self.complementary=0
            elif self.sign_of_ref[range.seqname]=='-':
                length=self.name2length[range.seqname]+1
                range.start=length-range.start
                range.end=length-range.end
                self.complementary=1
##                 range.reverse()  normalement pas besoin de reverse
    
#------------------------------------------------------------------------------

    def BuildBS(self,type_range):
        if type_range=='query':
            range=self.currentpathori.range_query
            #print 'self.currentpathori.range_query.start',self.currentpath.range_query.start,'self.currentpathori.range_query.end',self.currentpath.range_query.end
        elif type_range=='subject':
            range=self.currentpathori.range_subject
        if not range.isPlusStrand():
            range.reverse()
        
        bs=Bioseq()
        fastafile=open(self.Fastafile,'r')
        tempsub=None
        while 1:
            bs.read(fastafile)
            if bs.header==None or bs.sequence==None :
                break
            if bs.header==range.seqname:
                for i in self.list_of_path:
                    if i==self.currentpath:
                        number=self.list_of_path.index(i)
                        print 'number',number
                print 'range.start',range.start,'range.end',range.end
                tempsub=bs.subseq(range.start,range.end)
                if type_range=='query':
                    if self.complementaryQ:
                        print 'complQeri'
                        tempsub.sequence=tempsub.complement()
                if type_range=='subject':
                    if self.complementaryS:
                        print 'complSubjet'
                        tempsub.sequence=tempsub.complement()
                name=range.seqname.split(" ",1)[0]
                tempsub.header=name+"."+str(number)
                print 'header',tempsub.header
        return tempsub
                
#------------------------------------------------------------------------------

    def Build_bDB(self):
        bDB=BioseqDB()
        if self.type==0:  #query and subject
            bDB.add(self.BuildBS('query'))
            bDB.add(self.BuildBS('subject'))
        elif self.type==1:#subject included 
            bDB.add(self.BuildBS('query'))
        elif self.type==2:#query included
            bDB.add(self.BuildBS('subject'))
        else:
            print 'error in build_bDB()'
            sys.exit(0)
        return bDB
                
#------------------------------------------------------------------------------

    def update_data(self):
        for key in self.dico:# update of self.dico
            for range in self.dico[key]:
                if range[1]==self.profil_father:
                    range[1]=self.profil
                            
        for i in self.dico_profil:# update of self.dico_profil
            if i==self.profil_father:
                self.dico_profil[i]=None
    
#------------------------------------------------------------------------------

    def modify_data(self,complete=-1):
        if complete<=0:
            if self.type==0: #query and subject
                if self.number_of_clustal==None:
                    if self.currentpath.range_query.seqname not in self.dico:
                        self.dico[self.currentpath.range_query.seqname]=([[self.currentpath.range_query,self.profil,self.index]])
                    else:
                        self.dico[self.currentpath.range_query.seqname].append([self.currentpath.range_query,self.profil,self.index])
                    if self.currentpath.range_subject.seqname not in self.dico:
                        self.dico[self.currentpath.range_subject.seqname]=([[self.currentpath.range_subject,self.profil,self.index]])
                    else:
                        self.dico[self.currentpath.range_subject.seqname].append([self.currentpath.range_subject,self.profil,self.index])
                else:
                    if self.currentpath.range_query.seqname not in self.dico:
                        self.dico[self.currentpath.range_query.seqname]=([[self.currentpath.range_query,str(self.number_of_clustal),self.index]])
                    else:
                        self.dico[self.currentpath.range_query.seqname].append([self.currentpath.range_query,str(self.number_of_clustal),self.index])
                    if self.currentpath.range_subject.seqname not in self.dico:
                        self.dico[self.currentpath.range_subject.seqname]=([[self.currentpath.range_subject,str(self.number_of_clustal),self.index]])
                    else:
                        self.dico[self.currentpath.range_subject.seqname].append([self.currentpath.range_subject,str(self.number_of_clustal),self.index])
            elif self.type==1:#query 
                if self.currentpath.range_query.seqname not in self.dico:
                    self.dico[self.currentpath.range_query.seqname]=([[self.currentpath.range_query,self.profil,self.index]])
                else:
                    self.dico[self.currentpath.range_query.seqname].append([self.currentpath.range_query,self.profil,self.index])
                
            elif self.type==2:#subject
                if self.currentpath.range_subject.seqname not in self.dico:
                    self.dico[self.currentpath.range_subject.seqname]=([[self.currentpath.range_subject,self.profil,self.index]])
                else:
                    self.dico[self.currentpath.range_subject.seqname].append([self.currentpath.range_subject,self.profil,self.index])
            elif self.type==None:
                pass
            else:
                print 'error in update_data()'
                sys.exit(0)
        if complete:
            self.update_data()
            
#------------------------------------------------------------------------------

    def launchclustal1(self,bDB):#2 seqs   fasta
        if not os.path.exists('alignmentstmp2'):
            os.system('mkdir alignments')
        fichier_in="alignments/temp"+str(os.getpid())
        fichier_out="alignments/temp2.aln"+str(os.getpid())
        tempfile=open(fichier_in,'w')
        bDB.write(tempfile)
        tempfile.close()
        os.system('clustalw -TYPE=DNA -INFILE='+fichier_in+' -OUTFILE='+fichier_out)
        resultclustal=ReadClustal(fichier_out)
        AlbDB=resultclustal.buildAlbDB()
        os.system('rm -f '+fichier_in+' '+fichier_out+' alignments/*.dnd')
        return AlbDB
            
#------------------------------------------------------------------------------

    def launchclustal2(self,AlbDB1,AlbDB2):#2 profiles : 1 profil + 1 profil resulting from two sequences
        fichier_in="alignments/temp"+str(os.getpid())
        fichier_out="alignments/temp1.aln"+str(os.getpid())
        fichier_finalout="alignments/temp2.aln"+str(os.getpid()) 
        tempfile=open(fichier_in,'w')
        AlbDB2.write(tempfile)
        tempfile.close()
        os.system('clustalw -TYPE=DNA -INFILE='+fichier_in+' -OUTFILE='+fichier_out)
        tempfile=open(fichier_in,'w')
        AlbDB1.write(tempfile)
        tempfile.close()
        os.system('clustalw -TYPE=DNA -PROFILE1='+fichier_in+' -PROFILE2='+fichier_out+' -OUTFILE='+fichier_finalout)
        resultclustal=ReadClustal(fichier_finalout)
        AlbDB=resultclustal.buildAlbDB()
        os.system('rm -f '+fichier_in+' '+fichier_out+' '+fichier_finalout+' alignments/*.dnd')
        return AlbDB
            
#------------------------------------------------------------------------------

    def launchclustal3(self,AlbDB1,seq):# 1 profil + 1 seq or 1 profil + 1 profil
        fichier_inA="alignments/tempA"+str(os.getpid())
        fichier_inB="alignments/tempB"+str(os.getpid())
        fichier_out="alignments/temp2.aln"+str(os.getpid())
        tempfile=open(fichier_inA,'w')
        seq.write(tempfile)
        tempfile.close()
        tempfile2=open(fichier_inB,'w')
        AlbDB1.write(tempfile2)
        tempfile2.close()
        if isinstance(seq,AlignedBioseqDB):
            if AlbDB1.score>=seq.score:
                os.system('clustalw -sequences -TYPE=DNA -PROFILE1='+fichier_inB+' -PROFILE2='+fichier_inA+' -OUTFILE='+fichier_out)
            else:
                os.system('clustalw -sequences -TYPE=DNA -PROFILE1='+fichier_inA+' -PROFILE2='+fichier_inB+' -OUTFILE='+fichier_out)
        else:
            os.system('clustalw -sequences -TYPE=DNA -PROFILE1='+fichier_inB+' -PROFILE2='+fichier_inA+' -OUTFILE='+fichier_out)
        resultclustal=ReadClustal(fichier_out)
        AlbDB=resultclustal.buildAlbDB()
        os.system('rm -f '+fichier_inA+' '+fichier_inB+' '+fichier_out+' alignments/*.dnd')
        return AlbDB
            
#------------------------------------------------------------------------------

    def launchmuscle1(self,bDB):   #2 seqs fasta

        if not os.path.exists('alignments'):
            os.system('mkdir alignments')

        fichier_in = "alignments/temp"+str(os.getpid())
        fichier_out = "alignments/temp2aln"+str(os.getpid())
        tempfile = open(fichier_in,'w')
        bDB.write(tempfile)
        tempfile.close()

        os.system('muscle -in '+fichier_in+' -out '+fichier_out)
        AlbDB = AlignedBioseqDB()
        r = open(fichier_out,'r')
        AlbDB.read(r)
        r.close()
        os.system('rm -f '+fichier_in+' '+fichier_out)
        return AlbDB
            
#------------------------------------------------------------------------------

    def launchmuscle2(self,AlbDB1,AlbDB2):#2 profiles : 1 profil + 1 profil resulting from two sequences
        fichier_in="alignments/temp"+str(os.getpid())
        fichier_out="alignments/temp1.aln"+str(os.getpid())
        fichier_finalout="alignments/temp2aln"+str(os.getpid())    
        tempfile=open(fichier_in,'w')
        AlbDB2.write(tempfile)
        tempfile.close()
        os.system('muscle -in '+fichier_in+' -out '+fichier_out)
        tempfile=open(fichier_in,'w')
        AlbDB1.write(tempfile)
        tempfile.close()
        os.system('muscle -profile -in1 '+fichier_in+' -in2 '+fichier_out+' -out '+fichier_finalout)
        AlbDB=AlignedBioseqDB()
        r=open(fichier_finalout,'r')
        AlbDB.read(r)
        r.close()
        os.system('rm -f '+fichier_in+' '+fichier_out+' '+fichier_finalout)
        return AlbDB
            
#------------------------------------------------------------------------------

    def launchmuscle3(self,AlbDB1,seq):# 1 profil + 1 seq or 1 profil + 1 profil
        fichier_inA="alignments/tempA"+str(os.getpid())
        fichier_inB="alignments/tempB"+str(os.getpid())
        fichier_out="alignments/temp2aln"+str(os.getpid())
        tempfile=open(fichier_inA,'w')
        seq.write(tempfile)
        tempfile.close()
        tempfile2=open(fichier_inB,'w')
        AlbDB1.write(tempfile2)
        tempfile2.close()
        os.system('muscle -profile -in1 '+fichier_inB+' -in2 '+fichier_inA+' -out '+fichier_out)
        AlbDB=AlignedBioseqDB()
        r=open(fichier_out,'r')
        AlbDB.read(r)
        r.close()
        os.system('rm -f '+fichier_inA+' '+fichier_inB+' '+fichier_out)
        return AlbDB

#------------------------------------------------------------------------------

    def profils_ordered(self,list): # selon le Numero
        temp=[]
        for i in list:
            i=int(i)
            temp.append(i)
        temp.sort()
        list=[]
        for i in temp:
            i=str(i)
            list.append(i)
        return list

#------------------------------------------------------------------------------

    def profil_ordered_by_score(self,list):
        temp=[]
        for i in list:
            bisect.insort(temp,(-1*self.dico_profil[i].score,i))
        list=[]
        for i in temp:
            list.append(i[1])
        return list

#------------------------------------------------------------------------------

    def selectandorder(self,list):
        tmplist=[]
        for i in list:
            bisect.insort(tmplist,(-1*self.dico_profil[i[1]].score,i))
        list=[]
        for i in tmplist:
            list.append(i[1])
        i=0
        while i<len(list):
            j=i+1
            while j<len(list):
                if list[i][0].overlap(list[j][0]):
                    del list[j]
                else:
                    j+=1
            i+=1
        tmplist=[]
        for i in list:
            tmplist.append(i[1])
        return tmplist                    
    
#------------------------------------------------------------------------------

    def overlaping(self,Query,Subject):
        tmp=[]
        tmpQ=[]
        tmpS=[]
        tmprgQ=[]
        tmprgS=[]
        self.profils_to_align=[]
        self.query_overlap=0
        self.subject_overlap=0
        self.take_the_good_strand(Query)
        self.complementaryQ=self.complementary
        if Query.seqname in self.dico:
            for range in self.dico[Query.seqname]:
                if Query.overlap(range[0]):
                    if range[0].include(Query):
                        if range[1] not in tmp: # normalement Query ne peut etre inclus deux fois dans un meme profil dc cette ligne est apriori inutile
                            tmp.append(range[1])
                    else:
                        if range[1] not in tmprgQ:
                            tmprgQ.append(range)
            if tmp:
                self.query_overlap=2
                tmp=self.profil_ordered_by_score(tmp)
                self.profils_to_align.append(tmp[0])
            elif not tmp and tmprgQ:
                self.query_overlap=1
                self.profils_to_align=self.selectandorder(tmprgQ)
            elif not tmp and not tmprgQ:
                self.query_overlap=0

        self.take_the_good_strand(Subject)
        self.complementaryS=self.complementary
        tmp=[]
        if Subject.seqname in self.dico:
            for range in self.dico[Subject.seqname]:
                if Subject.overlap(range[0]):
                    if range[0].include(Subject):
                        if range[1] not in tmp: # normalement Subject ne peut etre inclus deux fois dans un meme profil dc cette ligne est apriori inutile
                            tmp.append(range[1])
                    else:
                        if range[1] not in tmprgS:
                            tmprgS.append(range)
            if tmp:
                self.subject_overlap=2
                tmp=self.profil_ordered_by_score(tmp)
                self.profils_to_align=self.profils_to_align+tmp[0:1]
            elif not tmp and tmprgS:
                self.subject_overlap=1
                self.profils_to_align=self.profils_to_align+self.selectandorder(tmprgS)
            elif not tmp and not tmprgS:
                self.subject_overlap=0
        
        print 'self.profils_to_align',self.profils_to_align
        #return queryOverlap,subjectOverlap
        
#------------------------------------------------------------------------------

#    def see_overlap( self, listPaths, prog ):
    def see_overlap( self, prog ):

#        listori = copy.deepcopy( listPaths )
        listori = copy.deepcopy( self.list_of_path )
        fileOverlap = open( "see_overlap", "w")

	for path in self.list_of_path:
            index = self.list_of_path.index( path )
            out = "path " + str( index )
            fileOverlap.write( out + "\n" )
            self.type = 0
            self.currentpathori = copy.deepcopy(path)
            self.currentpath = path
            query = path.range_query
            subject = path.range_subject
            out = "query: " + str(query.seqname)+" (length="+str(query.length())+")\n"
            out += "subject: "+str(subject.seqname)+" (length="+str(subject.length())+")"
            fileOverlap.write( out + "\n" )
            print out

            if query.length() == subject.length():
                out = "same lengths"
                print out
                fileOverlap.write( out + "\n" )
            else:
                out = "different lengths"
                print out
                fileOverlap.write( out + "\n" )

            self.take_the_good_strand( query )
            self.complementaryQ = self.complementary
            self.take_the_good_strand( subject )
            self.complementaryS = self.complementary
            if prog == 1:   # use ClustalW
                profil = self.launchclustal1( self.Build_bDB() )
            elif prog == 2:   # use Muscle
                profil = self.launchmuscle1( self.Build_bDB() )
            fichier = "profil" + str(index) + ".fa"
            tempfile = open( fichier, "w" )
            profil.write( tempfile )
            length = profil.db[0].length()
            first_pos = []
            last_pos = []

            for lign in profil.db:
                cpt=0
                if lign.sequence[0]=="-":
                    while lign.sequence[cpt]=="-":
                        cpt+=1
                    out="gap at the beginning, length "+str(cpt)
                    print out
                    fileOverlap.write(out+"\n")
                    if lign.header.split(".")[0]==listori[index].range_query.seqname.split(" ")[0]:
                        if self.sign_of_ref[subject.seqname]=="+":
                            if listori[index].range_subject.isPlusStrand():
                                listori[index].range_subject.start=listori[index].range_subject.start+cpt
                            else:
                                listori[index].range_subject.end=listori[index].range_subject.end+cpt
                        elif self.sign_of_ref[subject.seqname]=="-":
                            if listori[index].range_subject.isPlusStrand():
                                listori[index].range_subject.end=listori[index].range_subject.end-cpt
                            else:
                                listori[index].range_subject.start=listori[index].range_subject.start-cpt
                    elif lign.header.split(".")[0]==listori[index].range_subject.seqname.split(" ")[0]:
                        if self.sign_of_ref[query.seqname]=="+":
                            if listori[index].range_query.isPlusStrand():
                                listori[index].range_query.start=listori[index].range_query.start+cpt
                            else:
                                listori[index].range_query.end=listori[index].range_query.end+cpt
                        elif self.sign_of_ref[query.seqname]=="-":
                            if listori[index].range_query.isPlusStrand():
                                listori[index].range_query.end=listori[index].range_query.end-cpt
                            else:
                                listori[index].range_query.start=listori[index].range_query.start-cpt
                cpt=1
                if lign.sequence[length-cpt]=="-":
                    while lign.sequence[length-cpt]=="-":
                        cpt+=1
                    out="gap at the end, length "+str(cpt-1)
                    print out
                    fileOverlap.write(out+"\n")
                    if lign.header.split(".")[0]==listori[index].range_query.seqname.split(" ")[0]:
                        if self.sign_of_ref[subject.seqname]=="+":
                            if listori[index].range_subject.isPlusStrand():
                                listori[index].range_subject.end=listori[index].range_subject.end-(cpt-1)
                            else:
                                listori[index].range_subject.start=listori[index].range_subject.start-(cpt-1)#
                        elif self.sign_of_ref[subject.seqname]=="-":
                            if listori[index].range_subject.isPlusStrand():
                                listori[index].range_subject.start=listori[index].range_subject.start+(cpt-1)
                            else:
                                listori[index].range_subject.end=listori[index].range_subject.end+(cpt-1)#
                    elif lign.header.split(".")[0]==listori[index].range_subject.seqname.split(" ")[0]:
                        if self.sign_of_ref[query.seqname]=="+":
                            if listori[index].range_query.isPlusStrand():
                                listori[index].range_query.end=listori[index].range_query.end-(cpt-1)
                            else:
                                listori[index].range_query.start=listori[index].range_query.start-(cpt-1)#
                        elif self.sign_of_ref[query.seqname]=="-":
                            if listori[index].range_query.isPlusStrand():
                                listori[index].range_query.start=listori[index].range_query.start+(cpt-1)
                            else:
                                listori[index].range_query.end=listori[index].range_query.end+(cpt-1)#
            print
        self.list_of_path=listori

#------------------------------------------------------------------------------

#    def GoClustalw(self,list_for_alignment):
    def GoClustalw(self):
        included,overlap,no_overlap=2,1,0
        first=1
        re_init=1
#        number_of_path=len(list_for_alignment)
        number_of_path=len(self.list_of_path)
##         number_of_path=12
        print "number of path",number_of_path
#        for index in range(len(list_for_alignment)):
        for index in range(number_of_path):
##             if index==12:
##                 sys.exit(0)
            print
            print "boucle.....",index+1
            self.index=index
            self.currentpathori=copy.deepcopy(self.list_of_path[index])
##             self.currentpath=self.listcopy[index]
            self.currentpath=self.list_of_path[index]
            query=self.currentpath.range_query
            subject=self.currentpath.range_subject

            self.overlaping(query,subject) #query_overlap,subject_overlap=
            forget,temp=0,[] # si deux fois le meme profil alors on ignore
            for i in self.profils_to_align:
                if i not in temp:
                    temp.append(i)
                else:
                    forget=1
                    break
            if forget: continue
            
            print "querylap",self.query_overlap,"subjectlap",self.subject_overlap
            print "--->query",query.seqname,"subject",subject.seqname
            
            if self.query_overlap==included and self.subject_overlap==included:
                little_dico={}
                side="center"
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                self.type=None
                print "len(self.profils_to_align)",len(self.profils_to_align) #devrait etre egal au max a 2
##                 for i in self.dico:
##                     print i,self.dico[i]
                if len(self.profils_to_align)>1:
                    tmplist=None
                    tmplist=copy.deepcopy(self.profils_to_align)
                    
                    self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                    if tmplist==self.profils_to_align:
                        self.profil=self.profils_to_align[0] # de part la construction de overlaping(), [0]<=profil incluant query;[1]<=profil incluant subject
                        self.profil_father=self.profils_to_align[1]  ## for new update
                        tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,[query])
                        tmp_profil=self.cutting_profil_center("candidate_profilB",subject,self.profils_to_align[1],tmp_profil,[subject])
                        little_dico={"candidate_profil":self.profil,"candidate_profilB":self.profils_to_align[1]}
                    else:
                        self.profil=self.profils_to_align[1]
                        self.profil_father=self.profils_to_align[0]
                        tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,[query])
                        tmp_profil=self.cutting_profil_center("candidate_profilB",subject,self.profils_to_align[0],tmp_profil,[subject])
                        little_dico={"candidate_profil":self.profil,"candidate_profilB":self.profils_to_align[0]}
                        
                    tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][1],tmp_profil["to_align"][0]))
                    tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)

                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[self.profil_father].score+self.currentpath.score
                    self.modify_data()
                    self.get_last_profil(index,number_of_path)
                else:
                    self.get_last_profil(index,number_of_path)
            elif self.query_overlap==no_overlap and self.subject_overlap==no_overlap:
                self.type=0
                self.number_of_clustal=len(self.dico_profil)
                self.dico_profil[str(self.number_of_clustal)]=self.launchclustal1(self.Build_bDB())
                self.dico_profil[str(self.number_of_clustal)].score=self.currentpath.score
                self.modify_data(0)
                self.get_last_profil(index,number_of_path)
                self.number_of_clustal=None
                
            elif self.query_overlap==overlap and self.subject_overlap==overlap:
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                self.type=0
                self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                first=1
                candidateB=[]
                for profil in self.profils_to_align:
                    print "profil en traitement : ",profil
                    little_dico={}
                    seq_type=None
                    for i in self.dico[query.seqname]:  # necessaire pour determiner si le profil en traitement implique la query ou subject
                        if query.overlap(i[0]) and i[1]==profil:
                            seq_type=query
                            break
                    for i in self.dico[subject.seqname]:
                        if subject.overlap(i[0]) and i[1]==profil:
                            if seq_type!=None:
                                print "problem in Q1 S1"
                                sys.exit(0)
                            seq_type=subject
                            break
                    
                    candidateA=[]
                    for rang in self.dico[seq_type.seqname]:
                        if rang[1]==profil and seq_type.overlap(rang[0]):
                            candidateA.append(rang)
##                     print candidateA
                    
                    self.profil_father=profil
                    tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                    side=None
                    if first:
                        current_profil=str(len(self.dico_profil))
                        self.dico_profil[current_profil]=self.launchclustal1(self.Build_bDB())
                        self.dico_profil[current_profil].score=self.currentpath.score
                        self.profil=current_profil
                        self.modify_data(0)
                        first=0
                    
                    candidateB=self.get_item_and_clean(candidateA,profil) # de part la construction de candidateA ,besoin de cette etape ...
                    if len(candidateB)==0:
                        print "number of candidateB==0, in Q1,S1"
                        sys.exit(0)
                    tmp_coord_start=[]
                    tmp_coord_end=[]
                    for i in candidateB:
                        bisect.insort(tmp_coord_start,(i.start,i))
                        bisect.insort(tmp_coord_end,(i.end*-1,i))
                    tmp2_coord_start=[]
                    tmp2_coord_end=[]
                    for i in tmp_coord_start:
                        tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start
                    for i in tmp_coord_end:
                        tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end
                    
                    if len(candidateB)>1: #and len(self.profils_to_align)==1:
                        if tmp2_coord_start[0].start<=seq_type.start and tmp2_coord_end[0].end>=seq_type.end:
                            side="center"#rien
                            tmp_profil=self.cutting_profil_center("candidate_profil",seq_type,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil_center("candidate_profilB",seq_type,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                        elif tmp2_coord_start[0].start<=seq_type.start and tmp2_coord_end[0].end<seq_type.end:
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,seq_type,self.profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                            tmp_profil=self.cutting_profil("candidate_profil",side,seq_type,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        
                        elif tmp2_coord_start[0].start>seq_type.start and tmp2_coord_end[0].end>=seq_type.end:
                            side="right"
                            tmp_profil=self.cutting_profil("path",side,seq_type,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil("candidate_profil",side,seq_type,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in len(candidate)>1, in Q1,S1"
                            sys.exit(0)
                    
                    elif len(candidateB)==1:
                        if seq_type.include(candidateB[0]):
                            side="center" #rien
                            tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],self.profil,tmp_profil,candidateB)#seq_type
                            tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[seq_type])
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                        elif candidateB[0].include(seq_type):
                            side="center"
                            tmp_profil=self.cutting_profil_center("candidate_profil",seq_type,self.profil,tmp_profil,[seq_type])
                            tmp_profil=self.cutting_profil_center("candidate_profilB",seq_type,profil,tmp_profil,[seq_type])
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        
                        elif candidateB[0].start<=seq_type.start:# all range in self.dico are on the strand +
##                             print "seq_type",seq_type.seqname,"start",seq_type.start,"end",seq_type.end
##                             print "candidateB",candidateB[0].start,candidateB[0].end
                            if candidateB[0].end>seq_type.end:
                                print "Error with the candidateB, in Q1,S1"
                                sys.exit(0)
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,seq_type,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,seq_type,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                        elif candidateB[0].start>seq_type.start:
                            side="right"
##                             print "cest ici"
                            tmp_profil=self.cutting_profil("path",side,seq_type,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,seq_type,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in len(candidateB)==1, in Q1,S1"
                            sys.exit(0)
                    else:
                        print "Error in Q1,S1"
                        sys.exit(0)
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                    self.modify_data(1)
                if self.profils_to_align:
                    self.get_last_profil(index,number_of_path)
                else:
                    print "error in GoClustalw() Q=overlap S=overlap"
                    print "self.dico_profil",self.dico_profil
                    sys.exit(0)
                    
            elif (self.query_overlap==included or self.query_overlap==overlap) and self.subject_overlap==no_overlap:
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                if self.query_overlap==included:
                    little_dico={}
                    side=None
                    self.type=2
                    self.profil=self.profils_to_align[0]
                    tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,[query])
                    tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],self.Build_bDB()))
                    tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.currentpath.score
                    self.modify_data(0)
                    self.get_last_profil(index,number_of_path)
                else:
                    self.type=0
                    self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                    first=1
                    
                    candidateA=[]
                    for rang in self.dico[query.seqname]:
                        if rang[1] in self.profils_to_align and query.overlap(rang[0]):
                            candidateA.append(rang)
                    
                    candidateB=[]
                    for profil in self.profils_to_align:
                        little_dico={}
                        print "profil en traitement : ",profil
                        self.profil_father=profil
                        tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                        side=None
                        if first: # si je le met avant le for ,plus besoin de first
                            current_profil=str(len(self.dico_profil))
                            self.dico_profil[current_profil]=self.launchclustal1(self.Build_bDB())
                            self.dico_profil[current_profil].score=self.currentpath.score
                            self.profil=current_profil
                            self.modify_data(0)
                            first=0
                            
                        candidateB=self.get_item_and_clean(candidateA,profil)
                        
                        if len(candidateB)==0:
                            print "number of candidateB==0, in Q1,S0"
                            sys.exit(0)
                        tmp_coord_start=[]
                        tmp_coord_end=[]
                        for i in candidateB:
                            bisect.insort(tmp_coord_start,(i.start,i))
                            bisect.insort(tmp_coord_end,(i.end*-1,i))
                        tmp2_coord_start=[]
                        tmp2_coord_end=[]
                        for i in tmp_coord_start:
                            tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start (-...+)
                        for i in tmp_coord_end:
                            tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end (+...-)

                        
                        if len(candidateB)>1: #and len(self.profils_to_align)==1:
                            if tmp2_coord_start[0].start<=query.start and tmp2_coord_end[0].end>=query.end: #cas alpha : path dans profil_cand)
                                side="center"
                                tmp_profil=self.cutting_profil_center("candidate_profil",query,current_profil,tmp_profil,tmp2_coord_start) #"path"
                                tmp_profil=self.cutting_profil_center("candidate_profilB",query,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"candidate_profilB":profil,"candidate_profil":current_profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                            elif tmp2_coord_start[0].start<=query.start and tmp2_coord_end[0].end<query.end: #cas beta : path a droite de profil_cand
                                side="left"
                                tmp_profil=self.cutting_profil("path",side,query,current_profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                                tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":current_profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                            elif tmp2_coord_start[0].start>query.start and tmp2_coord_end[0].end>=query.end: #cas gamma : path a gauche de profil_cand
                                side="right"
                                tmp_profil=self.cutting_profil("path",side,query,current_profil,tmp_profil,tmp2_coord_start)
                                tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":current_profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            else:
                                print "Error in len(candidate)>1, in Q1,S0"
                                sys.exit(0)
                                
                        elif len(candidateB)==1:
##                             print "candidateB",candidateB[0].start,candidateB[0].end
##                             print "start",query.start,query.end
                            if query.include(candidateB[0]):
                                side="center"
                                tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],current_profil,tmp_profil,candidateB)#query
                                tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[query])
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"candidate_profilB":profil,"candidate_profil":current_profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                                
                            elif candidateB[0].start<=query.start:# all range in self.dico are on the strand +
                                if candidateB[0].end>query.end:
                                    print "Error with the candidateB, in Q1,S0"
                                    sys.exit(0)
##                                 print "candidateB",candidateB[0].start,candidateB[0].end
                                side="left"
                                tmp_profil=self.cutting_profil("path",side,query,current_profil,tmp_profil,candidateB)
                                tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,candidateB)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":current_profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                                
                            elif candidateB[0].start>query.start:
                                side="right"
                                tmp_profil=self.cutting_profil("path",side,query,current_profil,tmp_profil,candidateB)
                                tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,candidateB)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":current_profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in Q1,S0"
                            sys.exit(0)
                        self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                        self.modify_data(1)
                    if self.profils_to_align:
                        self.get_last_profil(index,number_of_path)
                    else:
                        print "error in GoClustalw() Q=overlap S=no-overlap"
                        print "self.dico_profil",self.dico_profil
                        sys.exit(0)
            elif self.query_overlap==no_overlap and (self.subject_overlap==included or self.subject_overlap==overlap):
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                if self.subject_overlap==included:
                    little_dico={}
                    side=None
                    self.type=1
                    self.profil=self.profils_to_align[0]
                    tmp_profil=self.cutting_profil_center("candidate_profil",subject,self.profil,tmp_profil,[subject])
                    tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],self.Build_bDB()))
                    tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.currentpath.score
                    self.modify_data(0)
                    self.get_last_profil(index,number_of_path)
                else:
                    self.type=0 
                    self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                    first=1
                    
                    candidateA=[]
                    for rang in self.dico[subject.seqname]:
                        if rang[1] in self.profils_to_align and subject.overlap(rang[0]):
                            candidateA.append(rang)
                    
                    candidateB=[]
                    for profil in self.profils_to_align:
                        little_dico={}
                        print "profil en traitement : ",profil
                        self.profil_father=profil
                        tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                        side=None
                        if first:
                            current_profil=str(len(self.dico_profil))
                            self.dico_profil[current_profil]=self.launchclustal1(self.Build_bDB())
                            self.dico_profil[current_profil].score=self.currentpath.score
                            self.profil=current_profil
                            self.modify_data(0)
                            first=0

                        candidateB=self.get_item_and_clean(candidateA,profil)
                        
                        if len(candidateB)==0:
                            print "number of candidateB==0, in Q0,S1"
                            sys.exit(0)
                        tmp_coord_start=[]
                        tmp_coord_end=[]
                        for i in candidateB:
                            bisect.insort(tmp_coord_start,(i.start,i))
                            bisect.insort(tmp_coord_end,(i.end*-1,i))
                        tmp2_coord_start=[]
                        tmp2_coord_end=[]
                        for i in tmp_coord_start:
                            tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start
                        for i in tmp_coord_end:
                            tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end

                        if len(candidateB)>1: #and len(self.profils_to_align)==1:
                            if tmp2_coord_start[0].start<=subject.start and tmp2_coord_end[0].end>=subject.end: #cas alpha : path dans profil_cand
                                side="center" #rien
                                tmp_profil=self.cutting_profil_center("candidate_profil",subject,current_profil,tmp_profil,[subject]) #"path"  tmp2_coord_start
                                tmp_profil=self.cutting_profil_center("candidate_profilB",subject,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"candidate_profilB":profil,"candidate_profil":current_profil} #"path":self.profil,"candidate_profil":profil
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            elif tmp2_coord_start[0].start<=subject.start and tmp2_coord_end[0].end<subject.end: #cas beta : path a droite de profil_cand
                                side="left"
                                tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                                tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][1],tmp_profil["to_align"][0]))
                                little_dico={"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            elif tmp2_coord_start[0].start>subject.start and tmp2_coord_end[0].end>=subject.end: #cas gamma : path a gauche de profil_cand
                                side="right"
                                tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,tmp2_coord_start)
                                tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            else:
                                print "Error in len(candidate)>1, in Q0,S1"
                                sys.exit(0)

                        elif len(candidateB)==1:
                            if subject.include(candidateB[0]):
                                side="center" #rien
##                                 tmp_profil=self.cutting_profil_center("candidate_profil",subject,current_profil,tmp_profil,candidateB)# "path"   [subject]
                                tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],current_profil,tmp_profil,candidateB)# ici candidateB no important 
                                tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[subject])
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"candidate_profilB":profil,"candidate_profil":current_profil} #{"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            elif candidateB[0].start<=subject.start:# all range in self.dico are on the strand +
                                if candidateB[0].end>subject.end:
##                                     print subject.seqname
##                                     print "candidateB[0].start",candidateB[0].start,"subject.start",subject.start
##                                     print "candidateB[0].end",candidateB[0].end,"subject.end",subject.end
                                    print "Error with the candidateB, in Q0,S1"
                                    sys.exit(0)
                                side="left"
                                tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,candidateB)
                                tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,candidateB)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            elif candidateB[0].start>subject.start:
                                side="right"
                                tmp_profil=self.cutting_profil("path",side,subject,current_profil,tmp_profil,candidateB)
                                tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,candidateB)
                                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error, in Q0,S1"
                            sys.exit(0)
                        self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                        self.modify_data(1)         
                    if self.profils_to_align:
                        self.get_last_profil(index,number_of_path)
                    else:
                        print "error in GoClustalw() Q=no-overlap S=overlap"
                        print "self.dico_profil",self.dico_profil
                        sys.exit(0)
            elif self.query_overlap==included and self.subject_overlap==overlap:
                little_dico={}
                side=None
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                self.type=2
                self.profil=self.profils_to_align[0]
                tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,[query])
                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],self.Build_bDB()))
                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.currentpath.score
                self.modify_data(0)
                
                if len(self.profils_to_align)>1:
                    del self.profils_to_align[0]                    
                self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                
                candidateA=[]
                for rang in self.dico[subject.seqname]:
                    if rang[1] in self.profils_to_align and subject.overlap(rang[0]):
                        candidateA.append(rang)
                candidateB=[]
                for profil in self.profils_to_align:
                    little_dico={}
                    self.profil_father=profil
                    tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                    side=None
                    candidateB=self.get_item_and_clean(candidateA,profil)
                    if len(candidateB)==0:
                        print "number of candidateB==0, in Q2,S1"
                        sys.exit(0)
                    tmp_coord_start=[]
                    tmp_coord_end=[]
                    for i in candidateB:
                        bisect.insort(tmp_coord_start,(i.start,i))
                        bisect.insort(tmp_coord_end,(i.end*-1,i))
                    tmp2_coord_start=[]
                    tmp2_coord_end=[]
                    for i in tmp_coord_start:
                        tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start
                    for i in tmp_coord_end:
                        tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end

                    
                    if len(candidateB)>1: #and len(self.profils_to_align)==1:
                        # je remplce current_profil par self.profil
                        if tmp2_coord_start[0].start<=subject.start and tmp2_coord_end[0].end>=subject.end: #cas alpha : path dans profil_cand)
                            side="center"
                            tmp_profil=self.cutting_profil_center("candidate_profil",subject,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil_center("candidate_profilB",subject,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif tmp2_coord_start[0].start<=subject.start and tmp2_coord_end[0].end<subject.end: #cas beta : path a droite de profil_cand
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                            tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif tmp2_coord_start[0].start>subject.start and tmp2_coord_end[0].end>=subject.end: #cas gamma : path a gauche de profil_cand
                            side="right"
                            tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in len(candidate)>1, in Q2,S1"
                            sys.exit(0)
                    elif len(candidateB)==1:
                        if subject.include(candidateB[0]):
                            side="center"
                            tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],self.profil,tmp_profil,[subject]) ##subject
                            tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[subject])
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif candidateB[0].start<=subject.start:# all range in self.dico are on the strand +
                            if candidateB[0].end>subject.end:
                                print "Error with the candidateB, in Q2,S1"
                                sys.exit(0)
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif candidateB[0].start>subject.start:
                            side="right"
                            tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                    else:
                        print "Error in Q2,S1"
                        sys.exit(0)
                    self.type=None
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                    self.modify_data(1)
                self.get_last_profil(index,number_of_path)
            elif self.query_overlap==overlap and self.subject_overlap==included:
                little_dico={}
                side=None
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                self.type=1
                self.profil=self.profils_to_align[-1]
                tmp_profil=self.cutting_profil_center("candidate_profil",subject,self.profil,tmp_profil,[subject])
                tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],self.Build_bDB()))
                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.currentpath.score
                self.modify_data(0)
                
                if len(self.profils_to_align)>1:
                    del self.profils_to_align[-1]                    
                self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                
                candidateA=[]
                for rang in self.dico[query.seqname]:
                    if rang[1] in self.profils_to_align and query.overlap(rang[0]):
                        candidateA.append(rang)
                
                candidateB=[]
                for profil in self.profils_to_align:
                    little_dico={}
                    self.profil_father=profil
                    tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                    side=None
                    candidateB=self.get_item_and_clean(candidateA,profil)
                    if len(candidateB)==0:
                        print "number of candidateB==0, in Q1,S2"
                        sys.exit(0)
                    tmp_coord_start=[]
                    tmp_coord_end=[]
                    for i in candidateB:
                        bisect.insort(tmp_coord_start,(i.start,i))
                        bisect.insort(tmp_coord_end,(i.end*-1,i))
                    tmp2_coord_start=[]
                    tmp2_coord_end=[]
                    for i in tmp_coord_start:
                        tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start
                    for i in tmp_coord_end:
                        tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end
                        
                    if len(candidateB)>1: #and len(self.profils_to_align)==1:
                        # je remplce current_profil par self.profil
                        if tmp2_coord_start[0].start<=query.start and tmp2_coord_end[0].end>=query.end: #cas alpha : path dans profil_cand)
                            side="center"
                            tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil_center("candidate_profilB",query,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif tmp2_coord_start[0].start<=query.start and tmp2_coord_end[0].end<query.end: #cas beta : path a droite de profil_cand
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,query,self.profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                            tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif tmp2_coord_start[0].start>query.start and tmp2_coord_end[0].end>=query.end: #cas gamma : path a gauche de profil_cand
                            side="right"
                            tmp_profil=self.cutting_profil("path",side,query,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in len(candidate)>1, in Q2,S1"
                            sys.exit(0)
                    elif len(candidateB)==1:
                        if query.include(candidateB[0]):
                            side="center" #rien
                            tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],self.profil,tmp_profil,[query])##query
                            tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[query])
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif candidateB[0].start<=query.start:# all range in self.dico are on the strand +
                            if candidateB[0].end>query.end:
                                print "Error with the candidateB, in Q2,S1"
                                sys.exit(0)
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,query,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif candidateB[0].start>query.start:
                            side="right"
                            tmp_profil=self.cutting_profil("path",side,query,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchclustal3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                    else:
                        print "Error in Q1,S2"
                        sys.exit(0)
                    self.type=None
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                    self.modify_data(1)
                self.get_last_profil(index,number_of_path)
            else:
                print "Error in Goclustalw"
                sys.exit(0)

#------------------------------------------------------------------------------

#    def GoMuscle( self, list_for_alignment ):
    def GoMuscle( self ):

        included, overlap, no_overlap = 2, 1, 0
        first = 1
        re_init = 1
        number_of_path = len(self.list_of_path)
        print "number of path",number_of_path

        print "\nself.dico:",self.dico
        print "self.dico_profil:",self.dico_profil

        for index in range(number_of_path):
            print
            print "boucle.....",index+1
            self.index=index
            self.currentpathori=copy.deepcopy(self.list_of_path[index])
##             self.currentpath=self.listcopy[index]
            self.currentpath=self.list_of_path[index]
            query=self.currentpath.range_query
            subject=self.currentpath.range_subject

            print "self.dico_profil before overlaping():",self.dico_profil
            self.overlaping(query,subject) #query_overlap,subject_overlap=
            print "self.dico_profil after overlaping():",self.dico_profil
            forget,temp=0,[] # si deux fois le meme profil alors on ignore
            for i in self.profils_to_align:
                if i not in temp:
                    temp.append(i)
                else:
                    forget=1
                    break
            if forget: continue
            
            print "querylap",self.query_overlap,"subjectlap",self.subject_overlap
            print "--->query",query.seqname,"subject",subject.seqname
            
            if self.query_overlap==included and self.subject_overlap==included:
                little_dico={}
                side="center"
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                self.type=None
                print "len(self.profils_to_align)",len(self.profils_to_align) #devrait etre egal au max a 2
                for i in self.dico:
                    print i,self.dico[i]
                if len(self.profils_to_align)>1:
                    tmplist=None
                    tmplist=copy.deepcopy(self.profils_to_align)
                    
                    self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                    print "self.profils_to_align",self.profils_to_align # test
                    if tmplist==self.profils_to_align:
                        self.profil=self.profils_to_align[0] # de part la construction de overlaping(), [0]<=profil incluant query;[1]<=profil incluant subject
                        self.profil_father=self.profils_to_align[1]  ## for new update
                        tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,[query])
                        tmp_profil=self.cutting_profil_center("candidate_profilB",subject,self.profils_to_align[1],tmp_profil,[subject])
                        little_dico={"candidate_profil":self.profil,"candidate_profilB":self.profils_to_align[1]}
                    else:
                        self.profil=self.profils_to_align[1]
                        self.profil_father=self.profils_to_align[0]
                        tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,[query])
                        tmp_profil=self.cutting_profil_center("candidate_profilB",subject,self.profils_to_align[0],tmp_profil,[subject])
                        little_dico={"candidate_profil":self.profil,"candidate_profilB":self.profils_to_align[0]}
                        
                    tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][1],tmp_profil["to_align"][0]))
                    tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)

                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[self.profil_father].score+self.currentpath.score
                    self.modify_data()
                    self.get_last_profil(index,number_of_path)
                else:
                    self.get_last_profil(index,number_of_path)

            elif self.query_overlap==no_overlap and self.subject_overlap==no_overlap:
                self.type=0
                self.number_of_clustal=len(self.dico_profil)
                self.dico_profil[str(self.number_of_clustal)]=self.launchmuscle1(self.Build_bDB())
                self.dico_profil[str(self.number_of_clustal)].score=self.currentpath.score
                self.modify_data(0)
                self.get_last_profil(index,number_of_path)
                self.number_of_clustal=None
                
            elif self.query_overlap==overlap and self.subject_overlap==overlap:
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                self.type=0
                self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                first=1
                candidateB=[]
                for profil in self.profils_to_align:
                    print "profil en traitement : ",profil
                    little_dico={}
                    seq_type=None
                    for i in self.dico[query.seqname]:  # necessaire pour determiner si le profil en traitement implique la query ou subject
                        if query.overlap(i[0]) and i[1]==profil:
                            seq_type=query
                            break
                    for i in self.dico[subject.seqname]:
                        if subject.overlap(i[0]) and i[1]==profil:
                            if seq_type!=None:
                                print "problem in Q1 S1"
                                sys.exit(0)
                            seq_type=subject
                            break
                    
                    candidateA=[]
                    for rang in self.dico[seq_type.seqname]:
                        print seq_type.seqname
                        print rang[1]
                        if rang[1]==profil and seq_type.overlap(rang[0]):
                            candidateA.append(rang)
                    print candidateA
                    
                    self.profil_father=profil
                    tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                    side=None
                    if first:
                        current_profil=str(len(self.dico_profil))
                        self.dico_profil[current_profil]=self.launchmuscle1(self.Build_bDB())
                        self.dico_profil[current_profil].score=self.currentpath.score
                        self.profil=current_profil
                        self.modify_data(0)
                        first=0
                    
                    candidateB=self.get_item_and_clean(candidateA,profil) # de part la construction de candidateA ,besoin de cette etape ...
                    if len(candidateB)==0:
                        print "number of candidateB==0, in Q1,S1"
                        sys.exit(0)
                    tmp_coord_start=[]
                    tmp_coord_end=[]
                    for i in candidateB:
                        bisect.insort(tmp_coord_start,(i.start,i))
                        bisect.insort(tmp_coord_end,(i.end*-1,i))
                    tmp2_coord_start=[]
                    tmp2_coord_end=[]
                    for i in tmp_coord_start:
                        tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start
                    for i in tmp_coord_end:
                        tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end
                    
                    if len(candidateB)>1: #and len(self.profils_to_align)==1:
                        if tmp2_coord_start[0].start<=seq_type.start and tmp2_coord_end[0].end>=seq_type.end: #cas alpha : path dans profil_cand)
                            side="center"#rien
                            tmp_profil=self.cutting_profil_center("candidate_profil",seq_type,self.profil,tmp_profil,tmp2_coord_start) #"path"
                            tmp_profil=self.cutting_profil_center("candidate_profilB",seq_type,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                        elif tmp2_coord_start[0].start<=seq_type.start and tmp2_coord_end[0].end<seq_type.end: #cas beta : path a droite de profil_cand
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,seq_type,self.profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                            tmp_profil=self.cutting_profil("candidate_profil",side,seq_type,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        
                        elif tmp2_coord_start[0].start>seq_type.start and tmp2_coord_end[0].end>=seq_type.end: #cas gamma : path a gauche de profil_cand
                            side="right"
                            tmp_profil=self.cutting_profil("path",side,seq_type,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil("candidate_profil",side,seq_type,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in len(candidate)>1, in Q1,S1"
                            sys.exit(0)
                    
                    elif len(candidateB)==1:
                        if seq_type.include(candidateB[0]):
                            side="center" #rien
                            tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],self.profil,tmp_profil,candidateB)#seq_type
                            tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[seq_type])
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                        elif candidateB[0].include(seq_type):
                            side="center"
                            tmp_profil=self.cutting_profil_center("candidate_profil",seq_type,self.profil,tmp_profil,[seq_type])
                            tmp_profil=self.cutting_profil_center("candidate_profilB",seq_type,profil,tmp_profil,[seq_type])
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        
                        elif candidateB[0].start<=seq_type.start:# all range in self.dico are on the strand +
                            if candidateB[0].end>seq_type.end:
                                print "Error with the candidateB, in Q1,S1"
                                sys.exit(0)
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,seq_type,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,seq_type,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                        elif candidateB[0].start>seq_type.start:
                            side="right"
                            print "cest ici"
                            tmp_profil=self.cutting_profil("path",side,seq_type,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,seq_type,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in len(candidateB)==1, in Q1,S1"
                            sys.exit(0)
                    else:
                        print "Error in Q1,S1"
                        sys.exit(0)
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                    self.modify_data(1)
                if self.profils_to_align:
                    self.get_last_profil(index,number_of_path)
                else:
                    print "error in GoClustalw() Q=overlap S=overlap"
                    print "self.dico_profil",self.dico_profil
                    sys.exit(0)
                    
            elif (self.query_overlap==included or self.query_overlap==overlap) and self.subject_overlap==no_overlap: ######
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                if self.query_overlap==included:
                    little_dico={}
                    side=None #"center"  je pense qu il faut mettre none pour ne pas interferer avec cas de double inclusion, corriger les autres
                    self.type=2
                    self.profil=self.profils_to_align[0]
                    tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,[query])
                    tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],self.Build_bDB()))
                    tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.currentpath.score
                    self.modify_data(0)
                    self.get_last_profil(index,number_of_path)
                else:
                    self.type=0
                    self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                    first=1
                    
                    candidateA=[]
                    for rang in self.dico[query.seqname]:
                        if rang[1] in self.profils_to_align and query.overlap(rang[0]):
                            candidateA.append(rang)
                    
                    candidateB=[]
                    for profil in self.profils_to_align:
                        little_dico={}
                        print "profil en traitement : ",profil
                        self.profil_father=profil
                        tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                        side=None
                        if first: # si je le met avant le for ,plus besoin de first
                            current_profil=str(len(self.dico_profil))
                            self.dico_profil[current_profil]=self.launchmuscle1(self.Build_bDB())
                            self.dico_profil[current_profil].score=self.currentpath.score
                            self.profil=current_profil
                            self.modify_data(0)
                            first=0
                            
                        candidateB=self.get_item_and_clean(candidateA,profil)
                        
                        if len(candidateB)==0:
                            print "number of candidateB==0, in Q1,S0"
                            sys.exit(0)
                        tmp_coord_start=[]
                        tmp_coord_end=[]
                        for i in candidateB:
                            bisect.insort(tmp_coord_start,(i.start,i))
                            bisect.insort(tmp_coord_end,(i.end*-1,i))
                        tmp2_coord_start=[]
                        tmp2_coord_end=[]
                        for i in tmp_coord_start:
                            tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start (-...+)
                        for i in tmp_coord_end:
                            tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end (+...-)
                        
                        if len(candidateB)>1: #and len(self.profils_to_align)==1:
                            if tmp2_coord_start[0].start<=query.start and tmp2_coord_end[0].end>=query.end: #cas alpha : path dans profil_cand)
                                side="center" #rien
                                tmp_profil=self.cutting_profil_center("candidate_profil",query,current_profil,tmp_profil,tmp2_coord_start) #"path"
                                tmp_profil=self.cutting_profil_center("candidate_profilB",query,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"candidate_profilB":profil,"candidate_profil":current_profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                            elif tmp2_coord_start[0].start<=query.start and tmp2_coord_end[0].end<query.end: #cas beta : path a droite de profil_cand
                                side="left"
                                tmp_profil=self.cutting_profil("path",side,query,current_profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                                tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":current_profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            
                            elif tmp2_coord_start[0].start>query.start and tmp2_coord_end[0].end>=query.end: #cas gamma : path a gauche de profil_cand
                                side="right"
                                tmp_profil=self.cutting_profil("path",side,query,current_profil,tmp_profil,tmp2_coord_start)
                                tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":current_profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            else:
                                print "Error in len(candidate)>1, in Q1,S0"
                                sys.exit(0)
                                
                        elif len(candidateB)==1:
                            if query.include(candidateB[0]):
                                side="center"
                                tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],current_profil,tmp_profil,candidateB)#query
                                tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[query])
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"candidate_profilB":profil,"candidate_profil":current_profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                                
                            elif candidateB[0].start<=query.start:# all range in self.dico are on the strand +
                                if candidateB[0].end>query.end:
                                    print "Error with the candidateB, in Q1,S0"
                                    sys.exit(0)
                                print "candidateB",candidateB[0].start,candidateB[0].end
                                side="left"
                                tmp_profil=self.cutting_profil("path",side,query,current_profil,tmp_profil,candidateB)
                                tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,candidateB)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":current_profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                                
                            elif candidateB[0].start>query.start:
                                side="right"
                                tmp_profil=self.cutting_profil("path",side,query,current_profil,tmp_profil,candidateB)
                                tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,candidateB)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":current_profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in Q1,S0"
                            sys.exit(0)
                        self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                        self.modify_data(1)
                    if self.profils_to_align:
                        self.get_last_profil(index,number_of_path)
                    else:
                        print "error in GoClustalw() Q=overlap S=no-overlap"
                        print "self.dico_profil",self.dico_profil
                        sys.exit(0)
            elif self.query_overlap==no_overlap and (self.subject_overlap==included or self.subject_overlap==overlap):
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                if self.subject_overlap==included:
                    little_dico={}
                    side=None
                    self.type=1
                    self.profil=self.profils_to_align[0]
                    tmp_profil=self.cutting_profil_center("candidate_profil",subject,self.profil,tmp_profil,[subject])
                    tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],self.Build_bDB()))
                    tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.currentpath.score
                    self.modify_data(0)
                    self.get_last_profil(index,number_of_path)
                else:
                    self.type=0 
                    self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                    first=1
                    
                    candidateA=[]
                    for rang in self.dico[subject.seqname]:
                        if rang[1] in self.profils_to_align and subject.overlap(rang[0]):
                            candidateA.append(rang)
                    
                    candidateB=[]
                    for profil in self.profils_to_align:
                        little_dico={}
                        print "profil en traitement : ",profil
                        self.profil_father=profil
                        tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                        side=None
                        if first:
                            current_profil=str(len(self.dico_profil))
                            self.dico_profil[current_profil]=self.launchmuscle1(self.Build_bDB())
                            self.dico_profil[current_profil].score=self.currentpath.score
                            self.profil=current_profil
                            self.modify_data(0)
                            first=0
                        candidateB=self.get_item_and_clean(candidateA,profil)
                        
                        if len(candidateB)==0:
                            print "number of candidateB==0, in Q0,S1"
                            sys.exit(0)
                        tmp_coord_start=[]
                        tmp_coord_end=[]
                        for i in candidateB:
                            bisect.insort(tmp_coord_start,(i.start,i))
                            bisect.insort(tmp_coord_end,(i.end*-1,i))
                        tmp2_coord_start=[]
                        tmp2_coord_end=[]
                        for i in tmp_coord_start:
                            tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start
                        for i in tmp_coord_end:
                            tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end

                        if len(candidateB)>1: #and len(self.profils_to_align)==1:
                            if tmp2_coord_start[0].start<=subject.start and tmp2_coord_end[0].end>=subject.end: #cas alpha : path dans profil_cand
                                side="center" #rien
                                tmp_profil=self.cutting_profil_center("candidate_profil",subject,current_profil,tmp_profil,[subject]) #"path"  tmp2_coord_start
                                tmp_profil=self.cutting_profil_center("candidate_profilB",subject,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"candidate_profilB":profil,"candidate_profil":current_profil} #"path":self.profil,"candidate_profil":profil
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            elif tmp2_coord_start[0].start<=subject.start and tmp2_coord_end[0].end<subject.end: #cas beta : path a droite de profil_cand
                                side="left"
                                tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                                tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][1],tmp_profil["to_align"][0]))
                                little_dico={"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            elif tmp2_coord_start[0].start>subject.start and tmp2_coord_end[0].end>=subject.end: #cas gamma : path a gauche de profil_cand
                                side="right"
                                tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,tmp2_coord_start)
                                tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,tmp2_coord_start)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            else:
                                print "Error in len(candidate)>1, in Q0,S1"
                                sys.exit(0)

                        elif len(candidateB)==1:
                            if subject.include(candidateB[0]):
                                side="center" #rien
##                                 tmp_profil=self.cutting_profil_center("candidate_profil",subject,current_profil,tmp_profil,candidateB)# "path"   [subject]
                                tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],current_profil,tmp_profil,candidateB)# ici candidateB no important 
                                tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[subject])
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"candidate_profilB":profil,"candidate_profil":current_profil} #{"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            elif candidateB[0].start<=subject.start:# all range in self.dico are on the strand +
                                if candidateB[0].end>subject.end:
                                    print "Error with the candidateB, in Q0,S1"
                                    sys.exit(0)
                                side="left"
                                tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,candidateB)
                                tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,candidateB)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                            elif candidateB[0].start>subject.start:
                                side="right"
                                tmp_profil=self.cutting_profil("path",side,subject,current_profil,tmp_profil,candidateB)
                                tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,candidateB)
                                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                                little_dico={"path":self.profil,"candidate_profil":profil}
                                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error, in Q0,S1"
                            sys.exit(0)
                        self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                        self.modify_data(1)         
                    if self.profils_to_align:
                        self.get_last_profil(index,number_of_path)
                    else:
                        print "error in GoClustalw() Q=no-overlap S=overlap"
                        print "self.dico_profil",self.dico_profil
                        sys.exit(0)
            elif self.query_overlap==included and self.subject_overlap==overlap:
                little_dico={}
                side=None
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                self.type=2
                self.profil=self.profils_to_align[0]
                tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,[query])
                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],self.Build_bDB()))
                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.currentpath.score
                self.modify_data(0)
                
                if len(self.profils_to_align)>1:
                    del self.profils_to_align[0]                    
                self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                
                candidateA=[]
                for rang in self.dico[subject.seqname]:
                    if rang[1] in self.profils_to_align and subject.overlap(rang[0]):
                        candidateA.append(rang)
                candidateB=[]
                for profil in self.profils_to_align:
                    little_dico={}
                    self.profil_father=profil
                    tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                    side=None
                    candidateB=self.get_item_and_clean(candidateA,profil)
                    if len(candidateB)==0:
                        print "number of candidateB==0, in Q2,S1"
                        sys.exit(0)
                    tmp_coord_start=[]
                    tmp_coord_end=[]
                    for i in candidateB:
                        bisect.insort(tmp_coord_start,(i.start,i))
                        bisect.insort(tmp_coord_end,(i.end*-1,i))
                    tmp2_coord_start=[]
                    tmp2_coord_end=[]
                    for i in tmp_coord_start:
                        tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start
                    for i in tmp_coord_end:
                        tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end
                    
                    if len(candidateB)>1:
                        # je remplce current_profil par self.profil
                        if tmp2_coord_start[0].start<=subject.start and tmp2_coord_end[0].end>=subject.end: #cas alpha : path dans profil_cand)
                            side="center" #rien
                            tmp_profil=self.cutting_profil_center("candidate_profil",subject,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil_center("candidate_profilB",subject,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif tmp2_coord_start[0].start<=subject.start and tmp2_coord_end[0].end<subject.end: #cas beta : path a droite de profil_cand
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                            tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif tmp2_coord_start[0].start>subject.start and tmp2_coord_end[0].end>=subject.end: #cas gamma : path a gauche de profil_cand
                            side="right"
                            tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in len(candidate)>1, in Q2,S1"
                            sys.exit(0)
                    elif len(candidateB)==1:
                        if subject.include(candidateB[0]):
                            side="center" #rien
                            tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],self.profil,tmp_profil,[subject]) ##subject
                            tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[subject])
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif candidateB[0].start<=subject.start:# all range in self.dico are on the strand +
                            if candidateB[0].end>subject.end:
                                print "Error with the candidateB, in Q2,S1"
                                sys.exit(0)
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif candidateB[0].start>subject.start:
                            side="right"
##                             print "left"
                            tmp_profil=self.cutting_profil("path",side,subject,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,subject,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                    else:
                        print "Error in Q2,S1"
                        sys.exit(0)
                    self.type=None
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                    self.modify_data(1)
                self.get_last_profil(index,number_of_path)
            elif self.query_overlap==overlap and self.subject_overlap==included:
                little_dico={}
                side=None
                tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                self.type=1
                self.profil=self.profils_to_align[-1]
                tmp_profil=self.cutting_profil_center("candidate_profil",subject,self.profil,tmp_profil,[subject])
                tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],self.Build_bDB()))
                tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.currentpath.score
                self.modify_data(0)
                
                if len(self.profils_to_align)>1:
                    del self.profils_to_align[-1]                    
                self.profils_to_align=self.profil_ordered_by_score(self.profils_to_align)
                
                candidateA=[]
                for rang in self.dico[query.seqname]:
                    if rang[1] in self.profils_to_align and query.overlap(rang[0]):
                        candidateA.append(rang)
                
                candidateB=[]
                for profil in self.profils_to_align:
                    little_dico={}
                    self.profil_father=profil
                    tmp_profil={"r":[],"l":[],"to_align":[],"aligned":[],"mem":[[],[],[]]}
                    side=None
                    candidateB=self.get_item_and_clean(candidateA,profil)
                    if len(candidateB)==0:
                        print "number of candidateB==0, in Q1,S2"
                        sys.exit(0)
                    tmp_coord_start=[]
                    tmp_coord_end=[]
                    for i in candidateB:
                        bisect.insort(tmp_coord_start,(i.start,i))
                        bisect.insort(tmp_coord_end,(i.end*-1,i))
                    tmp2_coord_start=[]
                    tmp2_coord_end=[]
                    for i in tmp_coord_start:
                        tmp2_coord_start.append(i[1]) # tmp1_coord_start=[range1,range2,...] ordered by start
                    for i in tmp_coord_end:
                        tmp2_coord_end.append(i[1]) # tmp1_coord_end=[rangeA,rangeB,...] ordered by end
                        
                    if len(candidateB)>1:
                        # je remplce current_profil par self.profil
                        if tmp2_coord_start[0].start<=query.start and tmp2_coord_end[0].end>=query.end: #cas alpha : path dans profil_cand)
                            side="center" #rien
                            tmp_profil=self.cutting_profil_center("candidate_profil",query,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil_center("candidate_profilB",query,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif tmp2_coord_start[0].start<=query.start and tmp2_coord_end[0].end<query.end: #cas beta : path a droite de profil_cand
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,query,self.profil,tmp_profil,tmp2_coord_start,tmp2_coord_end)
                            tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif tmp2_coord_start[0].start>query.start and tmp2_coord_end[0].end>=query.end: #cas gamma : path a gauche de profil_cand
                            side="right"
                            tmp_profil=self.cutting_profil("path",side,query,self.profil,tmp_profil,tmp2_coord_start)
                            tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,tmp2_coord_start)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        else:
                            print "Error in len(candidate)>1, in Q2,S1"
                            sys.exit(0)
                    elif len(candidateB)==1:
                        if query.include(candidateB[0]):
                            side="center" #rien
                            tmp_profil=self.cutting_profil_center("candidate_profil",candidateB[0],self.profil,tmp_profil,[query])##query
                            tmp_profil=self.cutting_profil_center("candidate_profilB",candidateB[0],profil,tmp_profil,[query])
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"candidate_profilB":profil,"candidate_profil":self.profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif candidateB[0].start<=query.start:# all range in self.dico are on the strand +
                            if candidateB[0].end>query.end:
                                print "Error with the candidateB, in Q2,S1"
                                sys.exit(0)
                            side="left"
                            tmp_profil=self.cutting_profil("path",side,query,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                        elif candidateB[0].start>query.start:
                            side="right"
                            tmp_profil=self.cutting_profil("path",side,query,self.profil,tmp_profil,candidateB)
                            tmp_profil=self.cutting_profil("candidate_profil",side,query,profil,tmp_profil,candidateB)
                            tmp_profil["aligned"].append(self.launchmuscle3(tmp_profil["to_align"][0],tmp_profil["to_align"][1]))
                            little_dico={"path":self.profil,"candidate_profil":profil}
                            tmp_profil=self.rebuilding_profil_stage1(tmp_profil,side,little_dico)
                    else:
                        print "Error in Q1,S2"
                        sys.exit(0)
                    self.type=None
                    self.dico_profil[self.profil].score=self.dico_profil[self.profil].score+self.dico_profil[profil].score
                    self.modify_data(1)
                self.get_last_profil(index,number_of_path)
            else:
                print "Error in Gomuscle"
                sys.exit(0)
    
#------------------------------------------------------------------------------

#    def GoAlignment(self,list_for_alignment,prog):
    def GoAlignment(self,prog):

        if prog==1:
#            self.GoClustalw(list_for_alignment)
            self.GoClustalw()

        elif prog==2:
            self.GoMuscle()

#------------------------------------------------------------------------------

    def get_last_profil(self,index,number_of_path):
        fasta=self.Fastafile.split("/")[len(self.Fastafile.split("/"))-1]
        if index==(number_of_path-1):
            print "view of self.dico_profil"
            for profil in self.dico_profil:
                if self.dico_profil[profil]:
                    print "No profil "+str(profil)+" score "+str(self.dico_profil[profil].score)
                    for j in self.dico_profil[profil].db:
                        print j.header
            for i in self.dico:
                for j in self.dico[i]:
                    print j[0].seqname,j[0].start,j[0].end,j[1]
            count=0
            for value in self.dico_profil.values():
                if value:
##                     value=self.profil_merger(value)
                    count+=1
                    fichier="alignments/"+fasta+"."+str(count)+"-"+str(os.getpid())+".fa_aln"
                    tempfile=open(fichier,"w")
                    value.write(tempfile)

#------------------------------------------------------------------------------

    def cutting_profil_center(self,case,rg,profil,tmp_profil,candidates):
        rang=copy.deepcopy(rg)
        if not rang.isPlusStrand():
            rang.reverse()
        pos_start,pos_end=None,None
        coord=[]
        if case=="path":
            ligns=[]
            index=1
            for bs in self.dico_profil[profil].db: ## recup, dans profil, des lignes ayant meme nom que rang
                if bs.header.split(".",1)[0]==rang.seqname.split(" ",1)[0]:
                    ligns.append(bs)
            print "nb lign",len(ligns)
            start=[]
            for rng in self.dico[rang.seqname]:
                if rng[1]==profil:
                    bisect.insort(start,(rng[0].start,rng[0])) #start=[(start1,range1),(start2,range2),..]
                    
            for i in start:
                coord.append(i[1].start)
                coord.append(i[1].end)    #coord=[start1,end1,start2,end2,...]
               
            print "coord",coord 
            self.coord_merger(coord)
            print "coord",coord
            
            eye,compt=coord[0]-1,0
            length_sequence=self.dico_profil[profil].db[0].length()
            cand=copy.deepcopy(candidates[0]) ## mettre condition :faire ceci si 1 seul element...sauf que pas forcement necessaire cf if len(candida..)>1
            if not cand.isPlusStrand():
                cand.reverse()
            print "rang.s",rang.start,"rang.e",rang.end
            print "nbr candidates",len(candidates)
            for i in range(length_sequence):
                ok=0
                for j in ligns:
                    if j.sequence[i]!="-":
                        ok=1
                        break
                if ok:
                    eye+=1
                
                compt+=1
                if len(candidates)>1:
                    if eye==rang.start:
                        pos_start=compt
                    if eye==rang.end:
                        pos_end=compt
                        length_sequence=bs.length()
                        break        
                else:
                    if eye==cand.start:
                        pos_start=compt
                    if eye==cand.end:
                        pos_end=compt
                        length_sequence=bs.length()
                        break
                if eye==coord[index]:
                    eye=coord[index+1]-1
                    index+=2
                        
            if pos_start>1:
                tmp_profil["l"].append((self.dico_profil[profil].get_sub_profil(1,pos_start-1),case))
            print pos_start,pos_end
            tmp_profil["to_align"].append(self.dico_profil[profil].get_sub_profil(pos_start,pos_end))
            if length_sequence>pos_end:
                tmp_profil["r"].append((self.dico_profil[profil].get_sub_profil(pos_end+1),case))

            tmp_profil["to_align"][0],tmp_profil=self.profil_cleaner(tmp_profil["to_align"][0],tmp_profil,"0")
            return tmp_profil

        elif case=="candidate_profil" or case=="candidate_profilB":
            ligns=[]
            index=1
            for bs in self.dico_profil[profil].db: ## recup, dans profil, des lignes ayant meme nom que rang
##                 print "header in",bs.header
                if bs.header.split(".",1)[0]==rang.seqname.split(" ",1)[0]:
##                     print "bs.header",bs.header
                    ligns.append(bs)
            print "nb lign",len(ligns)
##             for i in ligns:
##                 print i.header,len(i.sequence)
##                 print i.sequence
            
            start=[]
            for rng in self.dico[rang.seqname]:
                if rng[1]==profil:
                    bisect.insort(start,(rng[0].start,rng[0])) #start=[(start1,range1),(start2,range2),..]
            
            for i in start:
##                 print i[1].seqname,i[1].start,i[1].end
                coord.append(i[1].start)
                coord.append(i[1].end)    #coord=[start1,end1,start2,end2,...]
            
            print "coord",coord
            self.coord_merger(coord)
            print "coord",coord
            
            eye,compt=coord[0]-1,0
            length_sequence=self.dico_profil[profil].db[0].length()
            print "eye",eye
            print length_sequence
            print "c[0].s",candidates[0].start,"c[0].e",candidates[0].end
            cand=copy.deepcopy(candidates[0]) ## mettre condition :faire ceci si 1 seul element...sauf que pas forcement necessaire cf if len(candida..)>1
            if not cand.isPlusStrand():
                cand.reverse()
            print "c[0].s",candidates[0].start,"c[0].e",candidates[0].end
            print "rang.s",rang.start,"rang.e",rang.end
            print "nbr candidates",len(candidates)
            for i in range(length_sequence):
                ok=0
                for j in ligns:
                    if j.sequence[i]!="-":
                        ok=1
                        break
                if ok:
                    eye+=1
                compt+=1
                
                if eye==5612:
                    print "5612compt",compt
                    
                if len(candidates)>1:
                    if eye==rang.start:
                        pos_start=compt
                    if eye==rang.end:
                        pos_end=compt
                        length_sequence=bs.length()
                        break
                else:
                    if eye==rang.start:
                        pos_start=compt
                    if eye==rang.end:
                        pos_end=compt
                        length_sequence=bs.length()
                        break

                if eye==coord[index]:
                    eye=coord[index+1]-1
                    index+=2
            
            print pos_start,pos_end
            if pos_start>1:
                tmp_profil["l"].append((self.dico_profil[profil].get_sub_profil(1,pos_start-1),case))
            tmp_profil["to_align"].append(self.dico_profil[profil].get_sub_profil(pos_start,pos_end))
            if length_sequence>pos_end:
                tmp_profil["r"].append((self.dico_profil[profil].get_sub_profil(pos_end+1),case))
                
            if case=="candidate_profil" and len(tmp_profil["to_align"])==1:
                tmp_profil["to_align"][0],tmp_profil=self.profil_cleaner(tmp_profil["to_align"][0],tmp_profil,"0")
            elif case=="candidate_profil" and len(tmp_profil["to_align"])==2:
                tmp_profil["to_align"][1],tmp_profil=self.profil_cleaner(tmp_profil["to_align"][1],tmp_profil,"1")
            elif case=="candidate_profilB":
                tmp_profil["to_align"][1],tmp_profil=self.profil_cleaner(tmp_profil["to_align"][1],tmp_profil,"1")
                
            return tmp_profil
            
#------------------------------------------------------------------------------

    def cutting_profil(self,case,side,rg,profil,tmp_profil,candidate_start,candidate_end=None):
        rang=copy.deepcopy(rg)
        if not rang.isPlusStrand():
            rang.reverse()
        pos_start,pos_end=None,None
        coord=[]
        if side=="right":
            if case=="candidate_profil":
                ligns=[]
                index=1
                for bs in self.dico_profil[profil].db:
                    if bs.header.split(".",1)[0]==rang.seqname.split(" ",1)[0]:
                        ligns.append(bs)
                print "nb lign",len(ligns)
                start=[]
                for rng in self.dico[rang.seqname]:
                    if rng[1]==profil:
                        bisect.insort(start,(rng[0].start,rng[0])) #start=[(start1,range1),(start2,range2),..]
                for i in start:
                    coord.append(i[1].start)
                    coord.append(i[1].end)    #coord=[start1,end1,start2,end2,...]
                print "coord",coord
                self.coord_merger(coord)
                print "coord",coord
                
                eye,compt=coord[0]-1,0
                length_sequence=self.dico_profil[profil].db[0].length()
                print "eye",eye,"length",length_sequence
                print "c[0].s",candidate_start[0].start,"c[0].e",candidate_start[0].end
                print "nbr candidates",len(candidate_start)
                print "candidate_start[0].start",candidate_start[0].start,"rang.end",rang.end
                for i in range(length_sequence):
                    ok=0
                    for j in ligns:
                        if j.sequence[i]!="-":
                            ok=1
                            break
                    if ok:
                        eye+=1
                    compt+=1
                    
                    if eye==candidate_start[0].start: # coord[0]:  #coord[0]==first start
                        pos_start=compt
                    if eye==rang.end:
                        pos_end=compt
                        break
                    if eye==coord[index]:
                        eye=coord[index+1]-1
                        index+=2
                            
            elif case=="path":
                ligns=[]
                index=1
                for bs in self.dico_profil[profil].db:
                    if bs.header.split(".",1)[0]==rang.seqname.split(" ",1)[0]:
                        ligns.append(bs)
                print "nb lign",len(ligns)
                start=[]
                for rng in self.dico[rang.seqname]:
                    if rng[1]==profil:
                        bisect.insort(start,(rng[0].start,rng[0])) #start=[(start1,range1),(start2,range2),..]
                for i in start:
                    coord.append(i[1].start)
                    coord.append(i[1].end)    #coord=[start1,end1,start2,end2,...]
                
                print "coord",coord    
                self.coord_merger(coord)
                print "coord",coord
                
                eye,compt=coord[0]-1,0
                length_sequence=self.dico_profil[profil].db[0].length()
                print "eye",eye
                print "lenght",length_sequence
                print "c[0].s",candidate_start[0].start,"c[0].e",candidate_start[0].end
                print "nbr candidates",len(candidate_start)
                print "candidate_start[0].start",candidate_start[0].start,"rang.end",rang.end
                for i in range(length_sequence):
                    ok=0
                    for j in ligns:
                        if j.sequence[i]!="-":
                            ok=1
                            break
                    if ok:
                        eye+=1
                    compt+=1
                    if eye==candidate_start[0].start:
                        pos_start=compt
                    if eye==rang.end: #coord[-1]:
                        pos_end=compt
                        length_sequence=bs.length()
                        break
                    if eye==coord[index]:
                        eye=coord[index+1]-1
                        index+=2
                            
            print "posstart",pos_start,"posend",pos_end  
            if pos_start>1:
                tmp_profil["l"].append((self.dico_profil[profil].get_sub_profil(1,pos_start-1),case))
            tmp_profil["to_align"].append(self.dico_profil[profil].get_sub_profil(pos_start,pos_end))
            if length_sequence>pos_end:
                tmp_profil["r"].append((self.dico_profil[profil].get_sub_profil(pos_end+1),case))
                
            if case=="path":
                tmp_profil["to_align"][0],tmp_profil=self.profil_cleaner(tmp_profil["to_align"][0],tmp_profil,"0")
            elif case=="candidate_profil":
                tmp_profil["to_align"][1],tmp_profil=self.profil_cleaner(tmp_profil["to_align"][1],tmp_profil,"1")

            return tmp_profil
        
        elif side=="left":
            if case=="candidate_profil":
                ligns=[]
                index=1
                for bs in self.dico_profil[profil].db:
                    if bs.header.split(".",1)[0]==rang.seqname.split(" ",1)[0]:
                        ligns.append(bs)
                print "nb lign",len(ligns)
                
                start=[]
                for rng in self.dico[rang.seqname]:
                    if rng[1]==profil:
                        bisect.insort(start,(rng[0].start,rng[0])) #start=[(start1,range1),(start2,range2),..]
                for i in start:
                    coord.append(i[1].start)
                    coord.append(i[1].end)    #coord=[start1,end1,start2,end2,...]
                    
                print "coord",coord
                self.coord_merger(coord)
                print "coord",coord
                
                eye,compt=coord[0]-1,0
                length_sequence=self.dico_profil[profil].db[0].length()
                print "ccordoo[0]",coord[0],"coordoo[-1]",coord[-1]
                print "rangstart",rang.start,"candidate_start[0].end",candidate_start[0].end
                for i in range(length_sequence):
                    ok=0
                    for j in ligns:
                        if j.sequence[i]!="-":
                            ok=1
                            break
                    if ok:
                        eye+=1
                    compt+=1
                                     
                    if eye==rang.start:
##                         print "eye",eye
                        pos_start=compt
                    if eye==candidate_start[0].end: #coord[1]:  #coord[-1]==last end
##                         print compt
                        pos_end=compt
                        break
                    if eye==coord[index]:
##                         print "index"
                        eye=coord[index+1]-1
                        index+=2
                            
                print pos_start,pos_end
            elif case=="path":
                ligns=[]
                index=1
                for bs in self.dico_profil[profil].db:
                    if bs.header.split(".",1)[0]==rang.seqname.split(" ",1)[0]:
                        ligns.append(bs)
                print "nb lign",len(ligns)
                
                start=[]
                for rng in self.dico[rang.seqname]:
                    if rng[1]==profil:
                        bisect.insort(start,(rng[0].start,rng[0])) #start=[(start1,range1),(start2,range2),..]
                for i in start:
                    coord.append(i[1].start)
                    coord.append(i[1].end)    #coord=[start1,end1,start2,end2,...]
                
                print "coord",coord
                self.coord_merger(coord)
                print "coord",coord
                
                eye,compt=coord[0]-1,0
                length_sequence=self.dico_profil[profil].db[0].length()
                print "coordo[0]",coord[0],"coordo[-1]",coord[-1]
                print "rangstart",rang.start,"candidate_start[0].end",candidate_start[0].end
                if candidate_end!=None:
                    print "rangstart",rang.start,"candidate_end[0].end",candidate_end[0].end
                for i in range(length_sequence):
                    ok=0
                    for j in ligns:
                        if j.sequence[i]!="-":
                            ok=1
                            break
                    if ok:
                        eye+=1
                    compt+=1
                    if eye==rang.start: # coord[0]:
                        pos_start=compt
                    if candidate_end!=None:
                        if eye==candidate_end[0].end:
                            pos_end=compt
                            length_sequence=bs.length()
                            break
                    else:
                        if eye==candidate_start[0].end: 
                            pos_end=compt
                            length_sequence=bs.length()
                            break
                    if eye==coord[index]:
                        eye=coord[index+1]-1
                        index+=2
                        
                print "pos_start,pos_end",pos_start,pos_end

            if pos_start>1:
                tmp_profil["l"].append((self.dico_profil[profil].get_sub_profil(1,pos_start-1),case))
            print pos_start,pos_end
            tmp_profil["to_align"].append(self.dico_profil[profil].get_sub_profil(pos_start,pos_end))
            if length_sequence>pos_end:
                tmp_profil["r"].append((self.dico_profil[profil].get_sub_profil(pos_end+1),case))
                
            if case=="path":
                tmp_profil["to_align"][0],tmp_profil=self.profil_cleaner(tmp_profil["to_align"][0],tmp_profil,"0")
            elif case=="candidate_profil":
                tmp_profil["to_align"][1],tmp_profil=self.profil_cleaner(tmp_profil["to_align"][1],tmp_profil,"1")
                
            return tmp_profil
        
#------------------------------------------------------------------------------

    def coord_merger(self,list):
        i=0
        while i<len(list)-1:
            if list[i+1]>list[i]: i+=1
            else:
                if list[i+2]>list[i]:
                    del list[i:i+2]
                    i-=1
                else:
                    del list[i+1:i+3]
                        
#------------------------------------------------------------------------------

    def get_item_and_clean(self,list,item):
        b=[]
        i=0
        while i<len(list):
            if list[i][1]==item:
                b.append(list[i][0])
                del list[i]
            else:
                i+=1
        return b

#------------------------------------------------------------------------------

    def profil_cleaner(self,AlBDB,tmp_profil=None,N=None):
        dico={}
        if N!=None: N=int(N) # N=0 for tmp_profil[to_align][0], N=1 for tmp_profil[to_align][1], N=2 for tmp_profil[aligned]
        self.see_profil_line_by_line(AlBDB,dico)
        for header in dico:
            if dico[header]==0:
                for bseq in AlBDB.db:
                    if bseq.header==header:
                        AlBDB.db.remove(bseq)
                        if tmp_profil:
                            tmp_profil["mem"][N].append(header)
##                             print tmp_profil["mem"]
                        break
        if tmp_profil:
            return AlBDB,tmp_profil
        else:
            return AlBDB

#------------------------------------------------------------------------------

    def make_subconsensus(self,AlBDB):
        mismatch=[]
        subconsensus=Bioseq()
        lengthAli=AlBDB.length()
        for i in range(lengthAli):
            dico_nuc={}
            for bs in AlBDB.db:
                if bs.sequence[i]!="-":
                    if bs.sequence[i] not in dico_nuc.keys():
                        dico_nuc[bs.sequence[i]]=1
                    else:
                        dico_nuc[bs.sequence[i]]+=1
            if len(dico_nuc)>1:
                mismatch.append(i)
                subconsensus.sequence=subconsensus.sequence+"N"
            elif len(dico_nuc)==0:
                subconsensus.sequence=subconsensus.sequence+"-"
            elif len(dico_nuc)==1:
                subconsensus.sequence=subconsensus.sequence+dico_nuc.keys()[0]
        subconsensus.header=AlBDB.db[0].header.split(".")[0]
        if mismatch:
            print "Mismatch(es) for this subconsensus named ",subconsensus.header," at position(s): ",mismatch
        return subconsensus
                
#------------------------------------------------------------------------------

    def profil_merger(self,AlBDB):
        final_new_AlBDB=AlignedBioseqDB()
        mem=[]
        nb=len(AlBDB.db)
        for i in range(nb):
            if AlBDB.db[i].header.split(".")[0] in mem: continue
            new_AlBDB=AlignedBioseqDB()
            mem.append(AlBDB.db[i].header.split(".")[0])
            new_AlBDB.add(AlBDB.db[i])
            for j in range(i+1,nb):
                if AlBDB.db[i].header.split(".")[0]==AlBDB.db[j].header.split(".")[0]:
                    new_AlBDB.add(AlBDB.db[j])
            final_new_AlBDB.add(self.make_subconsensus(new_AlBDB))
        return final_new_AlBDB
    
#------------------------------------------------------------------------------

    def see_profil_line_by_line(self,AlBDB,dico): # dico={nameseq : nbr de nuc,...}
        for line in AlBDB.db:
            nb=0
            for nuc in line.sequence:
                if nuc!="-":
                    nb+=1
            dico[line.header]=nb

#------------------------------------------------------------------------------

    def little_backup(self,tmp_profil):
        length_aligned=tmp_profil["aligned"][0].length()
        lign_aligned=""
        length_to_align0=tmp_profil["to_align"][0].length()
        lign_to_align0=""
        if len(tmp_profil["to_align"])>1:
            length_to_align1=tmp_profil["to_align"][1].length()
            lign_to_align1=""
            for i in range(length_to_align1):
                lign_to_align1=lign_to_align1+"-"
        for i in range(length_aligned):
            lign_aligned=lign_aligned+"-"
        for i in range(length_to_align0):
            lign_to_align0=lign_to_align0+"-"
        for list in tmp_profil["mem"]:
            index=tmp_profil["mem"].index(list)
            for name in list:
##                 print "ajoute",name
                bs=Bioseq()
                bs.header=name
                bs1=copy.deepcopy(bs)
                bs1.sequence=lign_aligned
                tmp_profil["aligned"][0].add(bs1)
                if index==0:
                    bs.sequence=lign_to_align0
                    tmp_profil["to_align"][0].add(bs)
                elif index==1:
                    bs.sequence=lign_to_align1
                    tmp_profil["to_align"][1].add(bs)
        return tmp_profil
    
#------------------------------------------------------------------------------

    def rebuilding_profil_stage1(self,tmp_profil,side,dico):

        new_dico = {}
        new_dico_profil = {}

        tmp_profil = self.little_backup(tmp_profil)

        seq2del = []
        seq = []
        addGap = None
        LP, LC, LCB = None, None, None

        if len(tmp_profil["l"]) == 0:
            gap_size = 0

        elif len(tmp_profil["l"]) == 1:
            gap_size = tmp_profil["l"][0][0].db[0].length()

        else:
            for profil in tmp_profil["l"]:
                if profil[1]=="path":
                    LP=profil[0].db[0].length()
                if profil[1]=="candidate_profil":
                    LC=profil[0].db[0].length()
                if profil[1]=="candidate_profilB":
                    LCB=profil[0].db[0].length()

            if side=="right":
                C=[]
                dico_nb_nucA,dico_nb_nucB={},{}
                if LC<10 and LP<10:
##                     for profil in tmp_profil["l"]:
##                         if profil[1]=="path":
##                             pos=tmp_profil["l"].index(profil)
##                             break
##                     del tmp_profil["l"][pos]
##                     LP=0
                    pass # pour l instant on laisse passer, pas d elimination comme ci dessous
                elif LC<10 and LP>=10:
                    pass
                elif LC>=10:
                    if self.dico_profil[dico["path"]].score<self.dico_profil[dico["candidate_profil"]].score and LC>LP:
                        LP=0
                        new_dico,new_dico_profil=self.duplication(dico["path"],new_dico,new_dico_profil)
                        for profil in tmp_profil["l"]:
                            if profil[1]=="path":
                                position=tmp_profil["l"].index(profil)
                                self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                                break
                        self.see_profil_line_by_line(tmp_profil["to_align"][0],dico_nb_nucB) # recup des noms dans le ["to_align"] correspondant au "path"
                        for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                            if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                                C.append(name)
                            to_delete=[]
                            if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                                pos=int(name.split(".")[-1].split("_")[0])
                                nam=name.split(".")[0]
                                for i in self.dico:
                                    if i.split(" ")[0]==nam:
                                        for rg in self.dico[i]:
                                            if rg[1]==dico["path"] and rg[2]==pos:
                                                loc=self.dico[i].index(rg)
                                                to_delete.append(loc)
                                if not rg[0]:
                                    print "Error A0 in rebuilding_profil_stage1()"
                                    sys.exit(0)
                                print "to_delete",to_delete
                                for i in to_delete:
                                    print "a deleter",self.dico[rg[0].seqname][i]
                                    del self.dico[rg[0].seqname][i]
                        for name in C:
                            del dico_nb_nucA[name]
##                             del dico_nb_nucB[name]
                        for name in dico_nb_nucA.keys():
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["path"] and rg[2]==pos:
                                            print "p1rg[0].seqname",rg[0].seqname
                                            print "p1profil numberrg[1]",rg[1],"dico[path]",dico["path"]
                                            print "**p1rg[0].start",rg[0].start,"**rg[0].end",rg[0].end
                                            rg[0].start=rg[0].start+dico_nb_nucA[name] # coordonnee modifiee
                                            print "**rg[0].start",rg[0].start,"**rg[0].end",rg[0].end
                        del tmp_profil["l"][position]
                        
                    elif self.dico_profil[dico["path"]].score>self.dico_profil[dico["candidate_profil"]].score \
                             or (self.dico_profil[dico["path"]].score<self.dico_profil[dico["candidate_profil"]].score and LC<(LP/2.0)): #cf plus haut,cas de score egaux non traite
                        LC=0
                        new_dico,new_dico_profil=self.duplication(dico["candidate_profil"],new_dico,new_dico_profil)
                        for profil in tmp_profil["l"]:
                            if profil[1]=="candidate_profil":
                                position=tmp_profil["l"].index(profil)
                                self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                                break
                        self.see_profil_line_by_line(tmp_profil["to_align"][1],dico_nb_nucB) # recup des noms
                        for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                            if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                                C.append(name)
                            to_delete=[]
                            if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                                pos=int(name.split(".")[-1].split("_")[0])
                                nam=name.split(".")[0]
                                for i in self.dico:
                                    if i.split(" ")[0]==nam:
                                        for rg in self.dico[i]:
                                            if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                                loc=self.dico[i].index(rg)
                                                to_delete.append(loc)
                                if not rg[0]:
                                    print "Error 1A in rebuilding_profil_stage1()"
                                    sys.exit(0)
                                print "to_delete",to_delete
                                for i in to_delete:
                                    print "a deleter",self.dico[rg[0].seqname][i]
                                    del self.dico[rg[0].seqname][i]
                        for name in C:
                            del dico_nb_nucA[name]
                        for name in dico_nb_nucA.keys():
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                            print "c1rg[0].seqname",rg[0].seqname
                                            print "c1profil numberrg[1]",rg[1],"dico[candidate_profilB]",dico["candidate_profil"]
                                            print "**c1rg[0].start",rg[0].start,"**c1rg[0].end",rg[0].end
                                            rg[0].start=rg[0].start+dico_nb_nucA[name] # coordonnee modifiee
                                            print "**c1rg[0].start",rg[0].start,"**c1rg[0].end",rg[0].end
                        del tmp_profil["l"][position]
            
            if side=="left":
                C=[]
                dico_nb_nucA,dico_nb_nucB={},{}
                if LP<10:
                    pass
                elif LP>=10:
                    print "score path",self.dico_profil[dico["path"]].score,"score candid",self.dico_profil[dico["candidate_profil"]].score
                    if self.dico_profil[dico["path"]].score<self.dico_profil[dico["candidate_profil"]].score \
                           or self.dico_profil[dico["path"]].score>self.dico_profil[dico["candidate_profil"]].score and LP<(LC/2.0):
                        LP=0
                        new_dico,new_dico_profil=self.duplication(dico["path"],new_dico,new_dico_profil)
                        for profil in tmp_profil["l"]:
                            if profil[1]=="path":
                                position=tmp_profil["l"].index(profil)
                                self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                                break
                        self.see_profil_line_by_line(tmp_profil["to_align"][0],dico_nb_nucB) # recup des noms dans le ["to_align"] correspondant au "path" 
                        for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                            if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                                C.append(name)
                            to_delete=[]
                            if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                                pos=int(name.split(".")[-1].split("_")[0])
                                nam=name.split(".")[0]
                                for i in self.dico:
                                    if i.split(" ")[0]==nam:
                                        for rg in self.dico[i]:
                                            if rg[1]==dico["path"] and rg[2]==pos:
                                                loc=self.dico[i].index(rg)
                                                to_delete.append(loc)
                                if not rg[0]:
                                    print "Error B in rebuilding_profil_stage1()"
                                    sys.exit(0)
                                print "to_delete",to_delete
                                for i in to_delete:
                                    print "a deleter",self.dico[rg[0].seqname][i]
                                    del self.dico[rg[0].seqname][i]
                        for name in C:
                            del dico_nb_nucA[name]
                        for name in dico_nb_nucA.keys():
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["path"] and rg[2]==pos:
                                            print "***gh",rg[0].seqname,rg[0].start,rg[0].end
                                            rg[0].start=rg[0].start+dico_nb_nucA[name] # coordonnee modifiee
                                            print "*****gh",rg[0].seqname,rg[0].start,rg[0].end
                        del tmp_profil["l"][position]
                        
                    elif self.dico_profil[dico["path"]].score>self.dico_profil[dico["candidate_profil"]].score:
                        LC=0
                        new_dico,new_dico_profil=self.duplication(dico["candidate_profil"],new_dico,new_dico_profil)
                        for profil in tmp_profil["l"]:
                            if profil[1]=="candidate_profil":
                                position=tmp_profil["l"].index(profil)
                                self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                                break
                        self.see_profil_line_by_line(tmp_profil["to_align"][1],dico_nb_nucB) # recup des noms
                        for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                            if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                                C.append(name)
                            to_delete=[]
                            if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                                pos=int(name.split(".")[-1].split("_")[0])
                                nam=name.split(".")[0]
                                for i in self.dico:
                                    if i.split(" ")[0]==nam:
                                        for rg in self.dico[i]:
                                            if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                                loc=self.dico[i].index(rg)
                                                to_delete.append(loc)
                                if not rg[0]:
                                    print "Error O in rebuilding_profil_stage1()"
                                    sys.exit(0)
                                print "to_delete",to_delete
                                for i in to_delete:
                                    print "a deleter",self.dico[rg[0].seqname][i]
                                    del self.dico[rg[0].seqname][i]
                        for name in C:
                            del dico_nb_nucA[name]
                        for name in dico_nb_nucA.keys():
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                            print "lcrg[0].seqname",rg[0].seqname
                                            print "lcprofil numberrg[1]",rg[1],"dico[candidate_profil]",dico["candidate_profil"]
                                            print "**lcrg[0].start",rg[0].start,"**lcrg[0].end",rg[0].end
                                            rg[0].start=rg[0].start+dico_nb_nucA[name] # coordonnee modifiee
                                            print "**lcrg[0].start",rg[0].start,"**lcrg[0].end",rg[0].end
                        del tmp_profil["l"][position]
                        
            if side=="center":
                tmp_range=None
                C=[]
                dico_nb_nucA,dico_nb_nucB={},{}  # candidate_profil<==>LC, candidate_profilB<==>LCB  # LCB out
                if (self.dico_profil[dico["candidate_profil"]].score>self.dico_profil[dico["candidate_profilB"]].score and LC>=LCB) \
                       or (self.dico_profil[dico["candidate_profil"]].score>self.dico_profil[dico["candidate_profilB"]].score and LC>=(LCB/2.0)) \
                       or (self.dico_profil[dico["candidate_profil"]].score<self.dico_profil[dico["candidate_profilB"]].score and LCB<(LC/2.0)):
                    LCB=-1
                    new_dico,new_dico_profil=self.duplication(dico["candidate_profilB"],new_dico,new_dico_profil)
                    for profil in tmp_profil["l"]:
                        if profil[1]=="candidate_profilB":
                            position=tmp_profil["l"].index(profil)
                            self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                            break
                    self.see_profil_line_by_line(tmp_profil["to_align"][1],dico_nb_nucB) # recup des noms  ## [1]?
                    for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                        if (dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0):
                            C.append(name)
                        to_delete=[]
                        if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["candidate_profilB"] and rg[2]==pos:
                                            loc=self.dico[i].index(rg)
                                            to_delete.append(loc)
                            if not rg[0]:
                                print "Error O in rebuilding_profil_stage1()"
                                sys.exit(0)
                            print "to_delete",to_delete
                            for i in to_delete:
                                print "a deleter",self.dico[rg[0].seqname][i]
                                del self.dico[rg[0].seqname][i]
                    for name in C:
                        del dico_nb_nucA[name]
                    for name in dico_nb_nucA.keys():
                        pos=int(name.split(".")[-1].split("_")[0])
                        nam=name.split(".")[0]
                        print "nam",nam
                        for i in self.dico:
                            if i.split(" ")[0]==nam:
                                for rg in self.dico[i]:
                                    print "rg",rg
                                    if rg[1]==dico["candidate_profilB"] and rg[2]==pos:
                                        print "rg[0].seqname",rg[0].seqname
                                        print "rgprofil number[1]",rg[1],"dico[candidate_profilB]",dico["candidate_profilB"]
                                        print "**rg[0].start",rg[0].start,"**rg[0].end",rg[0].end
                                        rg[0].start=rg[0].start+dico_nb_nucA[name] # coordonnee modifiee
                                        print "**rg[0].start",rg[0].start,"**rg[0].end",rg[0].end

                elif (self.dico_profil[dico["candidate_profil"]].score<self.dico_profil[dico["candidate_profilB"]].score and LCB>=(LC/2.0)) \
                         or (self.dico_profil[dico["candidate_profil"]].score<self.dico_profil[dico["candidate_profilB"]].score and LC<=LCB) \
                         or (self.dico_profil[dico["candidate_profil"]].score>self.dico_profil[dico["candidate_profilB"]].score and LC<(LCB/2.0)):
                    LC=0
                    new_dico,new_dico_profil=self.duplication(dico["candidate_profil"],new_dico,new_dico_profil)
                    for profil in tmp_profil["l"]:
                        if profil[1]=="candidate_profil":
                            position=tmp_profil["l"].index(profil)
                            self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                            break
                    self.see_profil_line_by_line(tmp_profil["to_align"][0],dico_nb_nucB) # recup des noms  ## [1]? apparemment oui
                    for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                        if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                            C.append(name)
                        to_delete=[]
                        if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                            loc=self.dico[i].index(rg)
                                            to_delete.append(loc)
                            if not rg[0]:
                                print "Error O in rebuilding_profil_stage1()"
                                sys.exit(0)
                            print "to_delete",to_delete
                            for i in to_delete:
                                print "a deleter",self.dico[rg[0].seqname][i]
                                del self.dico[rg[0].seqname][i]
                    for name in C:
                        del dico_nb_nucA[name]
                    for name in dico_nb_nucA.keys():
                        pos=int(name.split(".")[-1].split("_")[0])
                        nam=name.split(".")[0]
                        for i in self.dico:
                            if i.split(" ")[0]==nam:
                                for rg in self.dico[i]:
                                    if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                        print "l2rg[0].seqname",rg[0].seqname
                                        print "l2profil numberrg[1]",rg[1],"dico[candidate_profil]",dico["candidate_profil"]
                                        print "**l2rg[0].start",rg[0].start,"**l2rg[0].end",rg[0].end
                                        rg[0].start=rg[0].start+dico_nb_nucA[name] # coordonnee modifiee
                                        print "**l2rg[0].start",rg[0].start,"**rg[0].end",rg[0].end
                
            
            if LCB:
                print "testttt"
                if LCB==-1:
                    for i in tmp_profil["l"][position][0].db:
                        seq2del.append(i.header)
                    del tmp_profil["l"][position]
                    print "testttt2"
                    LCB=0
                if LC==0:
                    for i in tmp_profil["l"][position][0].db:
                        seq2del.append(i.header)
                    del tmp_profil["l"][position]
                gap_size=abs(LC-LCB)
                if LC>LCB:
                    print "testttt10"
                    addGap="candidate_profilB"
                else:
                    addGap="candidate_profil"
            else:
                gap_size=abs(LP-LC)
                if LP>LC:
                    addGap="candidate_profil"
                else:
                    addGap="path"
        
        if len(tmp_profil["l"])==1:
            print "testttt4"
            gap_size=tmp_profil["l"][0][0].db[0].length()
            print "size gap",gap_size
            for bs in tmp_profil["l"][0][0].db:
                if bs.header not in seq2del:
                    seq.append(bs.header)
            
            ## print "seq",seq
            for i in range(tmp_profil["aligned"][0].size()):
                if tmp_profil["aligned"][0].db[i].header not in seq:
                    print "testttt5"
                    j=gap_size
                    while j:
                        tmp_profil["aligned"][0].db[i].sequence="-"+tmp_profil["aligned"][0].db[i].sequence
                        j-=1
        
        for profil in tmp_profil["l"]:
            for bs in profil[0].db:
                for i in range(tmp_profil["aligned"][0].size()):
                    if tmp_profil["aligned"][0].db[i].header==bs.header:
                        tmp_profil["aligned"][0].db[i].sequence=bs.sequence+tmp_profil["aligned"][0].db[i].sequence
                        if addGap==profil[1]:
                            print "***test6"
                            j=gap_size
                            while j:
                                tmp_profil["aligned"][0].db[i].sequence="-"+tmp_profil["aligned"][0].db[i].sequence
                                j-=1
                        break
        
        seq2del=[]
        seq=[]
        addGap=None
        RP,RC,RCB=None,None,None
        if len(tmp_profil["r"])==0:
            gap_size=0
        elif len(tmp_profil["r"])==1:
            gap_size=tmp_profil["r"][0][0].db[0].length()
        else:
            for profil in tmp_profil["r"]:
                if profil[1]=="path":
                    RP=profil[0].db[0].length()
                if profil[1]=="candidate_profil":
                    RC=profil[0].db[0].length()
                if profil[1]=="candidate_profilB":
                    RCB=profil[0].db[0].length()

            if side=="right":
                print "c est aussi ici"
                C=[]
                dico_nb_nucA,dico_nb_nucB={},{}
                if RP<10:
                    pass
                elif RP>=10:
                    if self.dico_profil[dico["path"]].score<self.dico_profil[dico["candidate_profil"]].score \
                    or (self.dico_profil[dico["path"]].score>self.dico_profil[dico["candidate_profil"]].score and RP<(RC/2.0)):
##                         print "c est la ici"                        
                        RP=0
                        if LP!=0:
                            new_dico,new_dico_profil=self.duplication(dico["path"],new_dico,new_dico_profil)
                        for profil in tmp_profil["r"]:
                            if profil[1]=="path":
                                position=tmp_profil["r"].index(profil)
                                self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                                break
                        self.see_profil_line_by_line(tmp_profil["to_align"][0],dico_nb_nucB) # recup des noms dans le ["to_align"] correspondant au "path"
##                         print "A",dico_nb_nucA
##                         print "B",dico_nb_nucB
                        for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                            if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                                C.append(name)
                            to_delete=[]
                            if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                                pos=int(name.split(".")[-1].split("_")[0])
                                nam=name.split(".")[0]
                                for i in self.dico:
                                    if i.split(" ")[0]==nam:
                                        for rg in self.dico[i]:
                                            if rg[1]==dico["path"] and rg[2]==pos:
                                                loc=self.dico[i].index(rg)
                                                to_delete.append(loc)
                                if not rg[0]:
                                    print "Error G in rebuilding_profil_stage1()"
                                    sys.exit(0)
                                print "to_delete",to_delete
                                for i in to_delete:
                                    print "a deleter",self.dico[rg[0].seqname][i]
                                    del self.dico[rg[0].seqname][i]
                                            
                        for name in C:
                            del dico_nb_nucA[name]
                        for name in dico_nb_nucA.keys():
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["path"] and rg[2]==pos:
                                            print "l2rg[0].seqname",rg[0].seqname
                                            print "l2profil number",rg[1],"dico[path]",dico["path"]
                                            print "**l2rg[0].start",rg[0].start,"**l2rg[0].end",rg[0].end
                                            rg[0].end=rg[0].end-dico_nb_nucA[name] # coordonnee modifiee
                                            print "**l2rg[0].start",rg[0].start,"**l2rg[0].end",rg[0].end
                        del tmp_profil["r"][position]
                    elif self.dico_profil[dico["path"]].score>self.dico_profil[dico["candidate_profil"]].score:
##                         print "c est la ici aussi"
                        RC=0
                        if LC!=0:
                            new_dico,new_dico_profil=self.duplication(dico["candidate_profil"],new_dico,new_dico_profil)
                        for profil in tmp_profil["r"]:
                            if profil[1]=="candidate_profil":
                                position=tmp_profil["r"].index(profil)
                                self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                                break
                        self.see_profil_line_by_line(tmp_profil["to_align"][1],dico_nb_nucB) # recup des noms
##                         print "A2",dico_nb_nucA
##                         print "B2",dico_nb_nucB
                        for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                            if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                                C.append(name)
                            to_delete=[]
                            if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                                pos=int(name.split(".")[-1].split("_")[0])
                                nam=name.split(".")[0]
                                for i in self.dico:
                                    if i.split(" ")[0]==nam:
                                        for rg in self.dico[i]:
                                            if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                                loc=self.dico[i].index(rg)  ## modifier les autres
                                                to_delete.append(loc)
                                if not rg[0]:
                                    print "Error I in rebuilding_profil_stage1()"
                                    sys.exit(0)
                                print "to_delete",to_delete
                                for i in to_delete:
                                    print "a deleter",self.dico[rg[0].seqname][i]
                                    del self.dico[rg[0].seqname][i]
                        for name in C:
                            del dico_nb_nucA[name]
                        for name in dico_nb_nucA.keys():
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                            print "rg[0].seqname",rg[0].seqname
                                            print "profil numberrg[1]",rg[1],"dico[candidate_profil]",dico["candidate_profil"]
                                            print "**rg[0].start",rg[0].start,"**rg[0].end",rg[0].end
                                            rg[0].end=rg[0].end-dico_nb_nucA[name] # coordonnee modifiee
                                            print "**rg[0].start",rg[0].start,"**rg[0].end",rg[0].end
                        del tmp_profil["r"][position]
            
            if side=="left":
                C=[]
                dico_nb_nucA,dico_nb_nucB={},{}
                if RC<10 and RP<10:
##                     for profil in tmp_profil["r"]:
##                         if profil[1]=="path":
##                             pos=tmp_profil["r"].index(profil)
##                             break
##                     del tmp_profil["r"][pos]
##                     RP=0
                    pass # pour l"instant on laisse passer, pas d elimination comme ci contre
                elif RC<10 and RP>=10:
                    pass
                elif RC>=10:
                    if self.dico_profil[dico["path"]].score<self.dico_profil[dico["candidate_profil"]].score and RC>RP:
                        RP=0
                        if LP!=0:
                            new_dico,new_dico_profil=self.duplication(dico["path"],new_dico,new_dico_profil)
                        for profil in tmp_profil["r"]:
                            if profil[1]=="path":
                                position=tmp_profil["r"].index(profil)
                                self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                                break
                        self.see_profil_line_by_line(tmp_profil["to_align"][0],dico_nb_nucB) # recup des noms dans le ["to_align"] correspondant au "path" 
                        for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                            if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                                C.append(name)
                            to_delete=[]
                            if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                                pos=int(name.split(".")[-1].split("_")[0])
                                nam=name.split(".")[0]
                                for i in self.dico:
                                    if i.split(" ")[0]==nam:
                                        for rg in self.dico[i]:
                                            if rg[1]==dico["path"] and rg[2]==pos:
                                                loc=self.dico[i].index(rg)
                                                to_delete.append(loc)
                                if not rg[0]:
                                    print "Error K in rebuilding_profil_stage1()"
                                    sys.exit(0)
                                print "to_delete",to_delete
                                for i in to_delete:
                                    print "a deleter",self.dico[rg[0].seqname][i]
                                    del self.dico[rg[0].seqname][i]
                        for name in C:
                            del dico_nb_nucA[name]
                        for name in dico_nb_nucA.keys():
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["path"] and rg[2]==pos:
                                            print "leftrg[0].seqname",rg[0].seqname
                                            print "leftprofil numberrg[1]",rg[1],"dico[path]",dico["path"]
                                            print "**leftrg[0].start",rg[0].start,"**leftrg[0].end",rg[0].end
                                            rg[0].end=rg[0].end-dico_nb_nucA[name] # coordonnee modifiee
                                            print "**leftrg[0].start",rg[0].start,"**leftrg[0].end",rg[0].end
                        del tmp_profil["r"][position]
                        
                    elif self.dico_profil[dico["path"]].score>self.dico_profil[dico["candidate_profil"]].score \
                             or (self.dico_profil[dico["path"]].score<self.dico_profil[dico["candidate_profil"]].score and RC<(RP/2.0)):
                        RC=0
                        if LC!=0:
                            new_dico,new_dico_profil=self.duplication(dico["candidate_profil"],new_dico,new_dico_profil)
                        for profil in tmp_profil["r"]:
                            if profil[1]=="candidate_profil":
                                position=tmp_profil["r"].index(profil)
                                self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                                break
                        self.see_profil_line_by_line(tmp_profil["to_align"][1],dico_nb_nucB) # recup des noms
                        for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                            if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                                C.append(name)
                            to_delete=[]
                            if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                                pos=int(name.split(".")[-1].split("_")[0])
                                nam=name.split(".")[0]
                                for i in self.dico:
                                    if i.split(" ")[0]==nam:
                                        for rg in self.dico[i]:
                                            if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                                loc=self.dico[i].index(rg)
                                                to_delete.append(loc)
                                if not rg[0]:
                                    print "Error OL in rebuilding_profil_stage1()"
                                    sys.exit(0)
                                print "to_delete",to_delete
                                for i in to_delete:
                                    print "a deleter",self.dico[rg[0].seqname][i]
                                    del self.dico[rg[0].seqname][i]
                        for name in C:
                            del dico_nb_nucA[name]
                        for name in dico_nb_nucA.keys():
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                            print "pathrg[0].seqname",rg[0].seqname
                                            print "pathprofil numberrg[1]",rg[1],"dico[candidate_profil]",dico["candidate_profil"]
                                            print "**pathrg[0].start",rg[0].start,"**pathrg[0].end",rg[0].end
                                            rg[0].end=rg[0].end-dico_nb_nucA[name] # coordonnee modifiee
                                            print "**pathrg[0].start",rg[0].start,"**rg[0].end",rg[0].end
                        del tmp_profil["r"][position]
                        
            if side=="center":
                C=[]
                dico_nb_nucA,dico_nb_nucB={},{}
                if (self.dico_profil[dico["candidate_profil"]].score>self.dico_profil[dico["candidate_profilB"]].score and RC>=RCB) \
                       or (self.dico_profil[dico["candidate_profil"]].score>self.dico_profil[dico["candidate_profilB"]].score and RC>=(RCB/2.0)) \
                       or (self.dico_profil[dico["candidate_profil"]].score<self.dico_profil[dico["candidate_profilB"]].score and RCB<(RC/2.0)):
                    RCB=-1
                    if LCB!=0:
                        new_dico,new_dico_profil=self.duplication(dico["candidate_profilB"],new_dico,new_dico_profil)
                    for profil in tmp_profil["r"]:
                        if profil[1]=="candidate_profilB":
                            position=tmp_profil["r"].index(profil)
                            self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                            break
                    self.see_profil_line_by_line(tmp_profil["to_align"][1],dico_nb_nucB) # recup des noms
##                     print "dico_nb_nucB",dico_nb_nucB
##                     print "dico_nb_nucA",dico_nb_nucA
                    for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                        if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                            C.append(name)
                        to_delete=[]
                        if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["candidate_profilB"] and rg[2]==pos:
                                            loc=self.dico[i].index(rg)
                                            to_delete.append(loc)
                            if not rg[0]:
                                print "Error O in rebuilding_profil_stage1()"
                                sys.exit(0)
                            print "to_delete",to_delete
                            for i in to_delete:
                                print "a deleter",self.dico[rg[0].seqname][i]
                                del self.dico[rg[0].seqname][i]
                    for name in C:
                        del dico_nb_nucA[name]
##                     print dico_nb_nucA
                    for name in dico_nb_nucA.keys():
                        pos=int(name.split(".")[-1].split("_")[0])
                        nam=name.split(".")[0]
                        for i in self.dico:
                            if i.split(" ")[0]==nam:
                                for rg in self.dico[i]:
                                    if rg[1]==dico["candidate_profilB"] and rg[2]==pos:
                                        print "***",rg[0].seqname,rg[0].start,rg[0].end
                                        rg[0].end=rg[0].end-dico_nb_nucA[name] # coordonnee modifiee
                                        print "*****",rg[0].seqname,rg[0].start,rg[0].end
                elif (self.dico_profil[dico["candidate_profil"]].score<self.dico_profil[dico["candidate_profilB"]].score and RCB>=(RC/2.0)) \
                         or (self.dico_profil[dico["candidate_profil"]].score<self.dico_profil[dico["candidate_profilB"]].score and RC<=RCB) \
                         or (self.dico_profil[dico["candidate_profil"]].score>self.dico_profil[dico["candidate_profilB"]].score and RC<(RCB/2.0)):
                    RC=0
                    if LC!=0:
                        new_dico,new_dico_profil=self.duplication(dico["candidate_profil"],new_dico,new_dico_profil)
                    for profil in tmp_profil["r"]:
                        if profil[1]=="candidate_profil":
                            position=tmp_profil["r"].index(profil)
                            self.see_profil_line_by_line(profil[0],dico_nb_nucA) # recup des noms
                            break
                    self.see_profil_line_by_line(tmp_profil["to_align"][0],dico_nb_nucB) # recup des noms
                    for name in dico_nb_nucA: # comparaison de A et B pour garder uniquement les ranges a modifier
                        if dico_nb_nucA[name]==0 or dico_nb_nucB[name]==0:
                            C.append(name)
                        to_delete=[]
                        if dico_nb_nucA[name]!=0 and dico_nb_nucB[name]==0:
                            pos=int(name.split(".")[-1].split("_")[0])
                            nam=name.split(".")[0]
                            for i in self.dico:
                                if i.split(" ")[0]==nam:
                                    for rg in self.dico[i]:
                                        if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                            loc=self.dico[i].index(rg)
                                            to_delete.append(loc)
                            if not rg[0]:
                                print "Error O2 in rebuilding_profil_stage1()"
                                sys.exit(0)
                            print "to_delete",to_delete
                            for i in to_delete:
                                print "a deleter",self.dico[rg[0].seqname][i]
                                del self.dico[rg[0].seqname][i]
                    for name in C:
                        del dico_nb_nucA[name]
                    for name in dico_nb_nucA.keys():
                        pos=int(name.split(".")[-1].split("_")[0])
                        nam=name.split(".")[0]
                        for i in self.dico:
                            if i.split(" ")[0]==nam:
                                for rg in self.dico[i]:
                                    if rg[1]==dico["candidate_profil"] and rg[2]==pos:
                                        print "***r2","rg[0].seqname",rg[0].seqname,"rg[0].start",rg[0].start,"rg[0].end",rg[0].end
                                        rg[0].end=rg[0].end-dico_nb_nucA[name] # coordonnee modifiee
                                        print "*****r2","rg[0].seqname",rg[0].seqname,"rg[0].start",rg[0].start,"rg[0].end",rg[0].end
            
            if RCB:
                if RCB==-1:
                    for i in tmp_profil["r"][position][0].db:
                        seq2del.append(i.header)
                    del tmp_profil["r"][position]
                    RCB=0
                if RC==0:
                    for i in tmp_profil["r"][position][0].db:
                        seq2del.append(i.header)
                    del tmp_profil["r"][position]
                gap_size=abs(RC-RCB)
                if RC>RCB:
                    addGap="candidate_profilB"
                else:
                    addGap="candidate_profil"
            else:
                gap_size=abs(RP-RC)
                if RP>RC:
                    addGap="candidate_profil"
                else:
                    addGap="path"
        
        if len(tmp_profil["r"])==1:
            gap_size=tmp_profil["r"][0][0].db[0].length()
##             print "left gap-size",gap_size
            for bs in tmp_profil["r"][0][0].db:
                if bs.header not in seq2del:
                    seq.append(bs.header)
##             print "left seq",seq
            for i in range(tmp_profil["aligned"][0].size()):
                if tmp_profil["aligned"][0].db[i].header not in seq:
                    print "jupiter"
                    j=gap_size
                    while j:
                        tmp_profil["aligned"][0].db[i].sequence=tmp_profil["aligned"][0].db[i].sequence+"-"
                        j-=1
        
        for profil in tmp_profil["r"]:
            for bs in profil[0].db:
                for i in range(tmp_profil["aligned"][0].size()):
                    if tmp_profil["aligned"][0].db[i].header==bs.header:
                        print "***test7"
                        tmp_profil["aligned"][0].db[i].sequence=tmp_profil["aligned"][0].db[i].sequence+bs.sequence
                        if addGap==profil[1]:
                            print "***test8"
                            j=gap_size
                            while j:
                                tmp_profil["aligned"][0].db[i].sequence=tmp_profil["aligned"][0].db[i].sequence+"-"
                                j-=1
                        break
        
        score=self.dico_profil[self.profil].score
        self.dico_profil[self.profil]=tmp_profil["aligned"][0]
        self.dico_profil[self.profil]=self.profil_cleaner(self.dico_profil[self.profil])
        self.dico_profil[self.profil].score=score
        self.splicing(self.dico_profil[self.profil])
        
        for nam in new_dico:
            for rng in new_dico[nam]:
                self.dico[nam].append(rng)
        for prof in new_dico_profil:
            self.dico_profil[prof]=new_dico_profil[prof]
    
        return tmp_profil  ## utile ?
    
#------------------------------------------------------------------------------

    def splicing(self,AlBDB):
        list=[]
        s=e=None
        for pos in range(AlBDB.length()):
            tmp=pos
            for bs in AlBDB.db:
                if bs.sequence[pos]!="-":
                    tmp=None
                    break
            if s!=None and e==None:
                if tmp!=None and pos==AlBDB.length()-1: #tmp forcement > etmp
                    e=tmp
                    list.append([s,e])
                elif tmp!=None:
                    etmp=tmp
                else:
                    e=etmp
                    list.append([s,e])
                    s=e=None
            if tmp!=None and s==None:
                s=etmp=tmp
        for bs in AlBDB.db:
            ind=AlBDB.db.index(bs)
            l=0
            for s,e in list:
                s,e=s-l,e-l # pr repercuter sur les coords suivantes la taille du gap elimine
                l=l+(e-s+1)
                bs.sequence=bs.sequence[:s]+bs.sequence[e+1:]
            AlBDB.db[ind]=bs
        return AlBDB
    
#------------------------------------------------------------------------------

    def duplication(self,name_profil,n_dico,n_dico_profil):
        new_profil=self.dico_profil[name_profil]
        new_name_profil=str(len(self.dico_profil)+len(n_dico_profil))
        
        if new_name_profil in self.dico_profil:
            print "Error in duplication()"
            sys.exit(0)
        else:
            n_dico_profil[new_name_profil]=copy.deepcopy(new_profil)
            for bs in n_dico_profil[new_name_profil].db:
                if "_" not in bs.header.split(".")[-1]:
                    bs.header=bs.header+"_"+str(self.dupli)
                else:
                    bs.header=bs.header.split("_")[0]+"_"+str(self.dupli)
        self.dupli+=1
            
        for name_seq in self.dico:
            for rng in self.dico[name_seq]:
                if rng[1]==name_profil:
                    if name_seq not in n_dico:
                        n_dico[name_seq]=([[copy.deepcopy(rng[0]),new_name_profil,rng[2]]])#([[rng[0],new_name_profil,rng[2]]]) deepcopy necessaire
                    else:
                        n_dico[name_seq].append([copy.deepcopy(rng[0]),new_name_profil,rng[2]])#([rng[0],new_name_profil,rng[2]]) deepcopy necessaire
                        
        return n_dico,n_dico_profil
