import sys
import biggles
import math

class PlotPath:

    def __init__(self):
        self.frame=biggles.FramedPlot()
        self.max_x=0
        self.max_y=0
        self.min_x=100000000
        self.min_y=100000000
        self.range_identity=[0.98,0.95,0.90,0.85,0.80,0.75,0.70,0.65,0.60]
        self.range_color=["red","orange","yellow","lightgreen","green","blue","darkblue","black"]

    def color(self,identity):
        for i in xrange(len(self.range_identity)):
            if identity>=self.range_identity[i] :
                if i<len(self.range_color):
                    color=self.range_color[i]
                else:
                    color="black"
                return color
            
        
    def plot(self,data,xlabel="",ylabel="",title="",min_q=-1,max_q=-1):

        self.frame.xlabel="$%s$"%xlabel.split()[0].replace("_","\_")
        self.frame.ylabel="$%s$"%ylabel.split()[0].replace("_","\_")
        self.frame.title=title
        self.frame.y1.ticklabels_style["fontsize"]=0.1
        self.frame.x.ticklabels_style["fontsize"]=0.5
        self.frame.x.ticklabels_style["textangle"]=10
        
        if min_q==-1:
            self.min_x=100000000
        else:
            self.min_x=min_q
        if max_q==-1:
            self.max_x=0
        else:
            self.max_x=max_q

        self.max_y=0
        self.min_y=100000000
        for k in data:
            k.sort()
            if k[0][0]>k[0][1]:
                k.reverse()
            for i in xrange(len(k)):
                seg=biggles.Curve(k[i][0],k[i][1],linewidth=3,\
                                          linetype="solid",\
                                  linecolor=self.color(k[i][2]))
                self.frame.add(seg)

                x1=k[i][0][0]
                y1=k[i][1][0]
                self.max_x=max(self.max_x,x1)
                self.max_y=max(self.max_y,y1)
                self.min_x=min(self.min_x,x1)
                self.min_y=min(self.min_y,y1)
                x2=k[i][0][1]
                y2=k[i][1][1]
                self.max_x=max(self.max_x,x2)
                self.max_y=max(self.max_y,y2)
                self.min_x=min(self.min_x,x2)
                self.min_y=min(self.min_y,y2)
                if i != len(k)-1:
                        

                    x1=x2
                    y1=y2
                    x2=k[i+1][0][0]     
                    y2=k[i+1][1][0]
                    
                    x=[x1,x2]
                    y=[y1,y2]
                        
                    connect=biggles.Curve(x,y,linewidth=1,\
                                          linetype="dash", linecolor="red")
                    self.frame.add(connect)
        self.plotlegend()

    def plotlegend(self):
        dx=math.floor((self.max_x-self.min_x)/len(self.range_identity))
        dy=math.floor((self.max_y-self.min_y)*0.1)
        y=self.max_y+dy

        x=self.min_x
        for i in self.range_identity:
            self.frame.add(biggles.Curve((x,x+dx-1),(y,y),linewidth=3,\
                                          linetype="solid", linecolor=self.color(i)))
            label="%d%%"%math.floor(i*100+0.5)
            self.frame.add(biggles.DataLabel(x+(dx/2)-1,y,label,\
                                             halign="center",valign="top"))

            x=x+dx

    def show(self):
        self.frame.show()

    def write(self,filename):
        self.frame.write_eps(filename+".ps")
        
