#! /usr/bin/env python

import os
import sys
import re
from pyRepet.seq.BioseqDB import BioseqDB
from pyRepet.seq.AlignedBioseqDB import AlignedBioseqDB

def launchmalign(bioseqDBin):
    fichier_in="/tmp/"+bioseqDBin.name+"_"+str(os.getpid())+".toalign"
    fichier_out="/tmp/"+bioseqDBin.name+"_"+str(os.getpid())+".aligned"
    bioseqDBin.save(fichier_in)
    print "malign is running..."
    os.system("nice malign "+fichier_in+" 20 -8 16 4 > "+fichier_out)
    print "malign finished"
    bioseqDBout=AlignedBioseqDB()
    bioseqDBout.load(fichier_out)
    if bioseqDBin.size()!=bioseqDBout.size():
        print "error aligning",bioseqDBin.name
        print bioseqDBin.length(),bioseqDBout.length()
        sys.exit()
    os.system("rm -f "+fichier_in+" "+fichier_out)
    return bioseqDBout

def launchlucy(bioseqDBin):
    fichier_in=bioseqDBin.name+"_"+str(os.getpid())+".toalign"
    fichier_out=bioseqDBin.name+"_"+str(os.getpid())+".aligned"
    bioseqDBin.save(fichier_in)
    print "lucy is running..."
    os.system("nice lucy2.py -f "+fichier_in+" -a 2")
    print "lucy finished"
    list_file_profile=os.listdir('./')
    list_profil=[]
    match=re.compile("^profil[0-9]+\.fa")
    for fichier_out in list_file_profile:
        if match.match(fichier_out)==None:
            continue
        bioseqDBout=AlignedBioseqDB()
        bioseqDBout.load(fichier_out)
        list_profil.append(bioseqDBout)
        os.system("rm -f "+fichier_out)
    os.system("rm -f "+fichier_in)
    return list_profil

def launchorienter(bioseqDBin):
    fichier_in_name="/tmp/"+bioseqDBin.name+"_"+str(os.getpid())+".toorient"
    bioseqDBin.write(open(fichier_in_name,'w'))
    print "orienter is running..."
    os.system("nice orienter "+fichier_in_name+" > /dev/null")
    bioseqDBout=BioseqDB(fichier_in_name+".oriented")
    os.system("rm -f "+fichier_in_name+" "+fichier_in_name+".oriented")
    return bioseqDBout
    
