#! /usr/bin/env python2

from pyRepet.seq.BioseqDB import * 
from pyRepet.seq.AlignedBioseqDB import * 
import os
import sys

def align(seq1,seq2,match=10,mism=8,gapo=16,gape=4,gapl=20):
    fichier1_in="toalign1_"+str(os.getpid())+".tmp"
    fichier2_in="toalign2_"+str(os.getpid())+".tmp"
    fichier_out="aligned_"+str(os.getpid())+".tmp"
    seq1.save(fichier1_in)
    seq2.save(fichier2_in)
    cmd="nice NWalign "+fichier1_in+" "+fichier2_in+\
         " -m "+str(match)+\
         " -d "+str(mism)+\
         " -g "+str(gapo)+\
         " -e "+str(gape)+\
         " -l "+str(gapl)+\
         " -D -o "+fichier_out
    os.system(cmd)
    bioseqDBout=AlignedBioseqDB()
    bioseqDBout.load(fichier_out)
    os.system("rm -f "+fichier1_in+" "+fichier2_in+" "+fichier_out)
    return bioseqDBout

def fastlalign(seq1,seq2,match=10,mism=8,gapo=16,gape=4,gapl=20):
    fichier1_in="/tmp/toalign1_"+str(os.getpid())+".tmp"
    fichier2_in="/tmp/toalign2_"+str(os.getpid())+".tmp"
    fichier_out="/tmp/aligned_"+str(os.getpid())+".tmp"
    seq1.save(fichier1_in)
    seq2.save(fichier2_in)
    cmd="nice fastlalign "+fichier1_in+" "+fichier2_in+\
         " -m "+str(match)+\
         " -d "+str(mism)+\
         " -g "+str(gapo)+\
         " -e "+str(gape)+\
         " -l "+str(gapl)+\
         " -D -o "+fichier_out
    os.system(cmd)
    bioseqDBout=AlignedBioseqDB()
    bioseqDBout.load(fichier_out)
    os.system("rm -f "+fichier1_in+" "+fichier2_in+" "+fichier_out)
    return bioseqDBout

def malign(bioseqDBin,mism,gapo,gape,gapl):
    fichier_in="/tmp/toalign_"+str(os.getpid())+".tmp"
    fichier_out="/tmp/aligned_"+str(os.getpid())+".tmp"
    bioseqDBin.save(fichier_in)
    print "malign is running..."
    os.system("nice malign "+fichier_in+\
              " "+str(gapl)+" "+str(mism)+" "+str(gapo)+" "+str(gape)+\
              " > "+fichier_out)
    print "malign finished"
    bioseqDBout=AlignedBioseqDB()
    bioseqDBout.load(fichier_out)
    os.system("rm -f "+fichier_in+" "+fichier_out)
    return bioseqDBout

def orienter(bioseqDBin,match=1,mism=3,gapo=5,gape=2,signif_len=30):
    fichier_in="toalign_"+str(os.getpid())+".tmp"
    fichier_out=fichier_in+".oriented"
    bioseqDBin.save(fichier_in)
    print "orienter is running..."
    os.system("nice orienter "+fichier_in+\
              " -m "+str(match)+\
              " -d "+str(mism)+\
              " -g "+str(gapo)+\
              " -e "+str(gape)+\
              " -l "+str(signif_len))
    print "orienter finished"
    bioseqDBout=AlignedBioseqDB()
    bioseqDBout.load(fichier_out)
    os.system("rm -f "+fichier_in+" "+fichier_out)
    return bioseqDBout

    
