import os
import unittest
from FileUtils import *


class TestFile(unittest.TestCase):
    
    def setUp(self):
        self.fileUtils = FileUtils()
        # here files
         
        self.file1 = "datas/batch_1.fa"
        self.file2 = "datas/batch_2.fa"
        self.file3 = "datas/batch_3.fa"
        self.file4 = "datas/batch_4.fa"
        self.file5 = "datas/batch_5.fa"
        self.file6 = "datas/batch_6.fa"
        self.file7 = "datas/batch_7.fa"
        self.filesList = [self.file1, self.file2, self.file3 ,self.file4, self.file5, self.file6 ,self.file7]
    
    def testCountLinesInASingleFile(self):
       self.assertEqual(836,self.fileUtils.countLinesInAFile(self.file1))
       self.assertEqual(836,self.fileUtils.countLinesInAFile(self.file2))
       self.assertEqual(836,self.fileUtils.countLinesInAFile(self.file3))
       self.assertEqual(836,self.fileUtils.countLinesInAFile(self.file4))
       self.assertEqual(836,self.fileUtils.countLinesInAFile(self.file5))
       self.assertEqual(836,self.fileUtils.countLinesInAFile(self.file6))
       self.assertEqual(335,self.fileUtils.countLinesInAFile(self.file7))
  
    def testCountLinesInManyFiles(self):
        self.assertEqual(5351,self.fileUtils.countLinesInFiles(self.filesList))
                        
    def testConcatFiles(self):
        self.fileUtils.concatFiles(self.filesList, "concatFiles.txt")
        self.assertEqual(5351,self.fileUtils.countLinesInAFile("concatFiles.txt"))
        os.remove("concatFiles.txt")
           
        
if __name__ == "__main__":
	unittest.main()                 
